/*
 *	menu.h: Menu definitions for the calibrate application.
 *
 */
#ifndef menu_h_INCLUDED
#define menu_h_INCLUDED


/*
 * Specify FILE pulldown pane.
 */
static Menu_Entry FileMenu[] = {
   	{ 
		"About Calibrate",
		'V',
		cb_about_calibrate,
		NULL,
		NULL,
		0,   
		NULL,
		NULL,
		NULL 
	},
	{ 
		NULL, NULL, NULL, (caddr_t)NULL, NULL, 0, NULL, NULL, NULL
	},
	{
		"Adaptor ", 
		'A', 
		NULL,
		NULL, 
		(Menu_Entry*)&p_adaptors_list, 
		0, 
		NULL,
		NULL,
		NULL
	},
	{ 
		NULL, NULL, NULL, (caddr_t)NULL, NULL, 0, NULL, NULL, NULL
	},
    {
		"Default...",  
		'D',
		cb_default, 
		(caddr_t)&me, 
		NULL, 
		0, 
		NULL, 
		0,
                NULL
	},
    {
		NULL, NULL, NULL, (caddr_t)NULL, NULL, 0, NULL, NULL, NULL
	},
	{"Load  ",'L', cb_nvram_load,  (caddr_t)&me,    NULL, 0, NULL,NULL,NULL},
	{"Save  ",'S', cb_nvram_store, (caddr_t)&me,    NULL, 0, NULL,NULL,NULL},
    {
		NULL, NULL, NULL, (caddr_t)NULL, NULL, 0, NULL, NULL, NULL
	},
    {
		"Exit",    
		'x',          
		cb_exit, 
		(caddr_t)NULL, 
		NULL, 
		0, 
		NULL, 
		NULL,
		NULL
	}
};

/*
 * Specify ZOOM pulldown pane.
 */
static Menu_Entry ZoomMenu[] = {
  {"Normal", '1', cb_zoom, (char*)1, NULL, 0, NULL, NULL,NULL},
  {"Zoom 2", '2', cb_zoom, (char*)2, NULL, 0, NULL, NULL,NULL},
};


/*
 * Specify HELP pulldown pane.
 */
static Menu_Entry HelpMenu[] = {
  {"What to do ...", 'W', cb_help, "Calibrate", NULL, 0, NULL, NULL,NULL},
  {"Adjust     ...", 'A', cb_help, "Adjust", NULL, 0, NULL, NULL,NULL},
  {"File       ...", 'F', cb_help, "File",   NULL, 0, NULL, NULL,NULL},
  {"Title      ...", 'T', cb_help, "Title",  NULL, 0, NULL, NULL,NULL},
  {"Zoom       ...", 'Z', cb_help, "Zoom",   NULL, 0, NULL, NULL,NULL},
};

/*
 * Specify the menu bar:
 *    give the names to appear in the menu bar and 
 *    pointers to each pulldown pane.
 */
static Menu_Entry MenuBar[] = {
  {"File ",  'F',NULL,NULL, FileMenu,    XtNumber(FileMenu),  NULL,NULL,NULL},
  {"Zoom ",  'Z',NULL,NULL, ZoomMenu,    XtNumber(ZoomMenu),  NULL,NULL,NULL},
  {"Help",   'H',NULL,NULL, HelpMenu,    XtNumber(HelpMenu),  NULL,NULL,NULL}
};

#endif /* menu_h_INCLUDED */
