/*
 *	xmtv_menu.h: Menu definitions for the tv application.
 *
 */
#ifndef xmtv_menu_h_INCLUDED
#define xmtv_menu_h_INCLUDED


/*
 * Specify FILE pulldown pane.
 */
static Menu_Entry FileMenu[] = {
   	{ 
		"About XMTV",
		'A',
		cb_about_xmtv,
		NULL,
		NULL,
		0,   
		NULL,
			NULL,
			NULL 
	},
    {
		NULL, NULL, NULL, (caddr_t)NULL, NULL, 0, NULL, NULL, NULL
	},
    {"Exit",      'x',  cb_exit,    (caddr_t)0, NULL, 0, NULL, NULL, NULL }
};

/*
 * Specify HELP pulldown pane.
 */
static Menu_Entry HelpMenu[] = {
  {"File   ...", 'F', cb_help, "File",    NULL, 0, NULL, NULL,NULL},
  {"Inputs ...", 'I', cb_help, "Inputs",  NULL, 0, NULL, NULL,NULL},
  {"Outputs...", 'O', cb_help, "Outputs", NULL, 0, NULL, NULL,NULL}
};

/*
 * Specify the menu bar:
 *    give the names to appear in the menu bar and 
 *    pointers to each pulldown pane.
 */
static Menu_Entry MenuBar[] = {
  {"File   ", 'F',NULL,NULL, FileMenu,     XtNumber(FileMenu),  NULL,NULL,NULL},
  {"Inputs ", 'I',NULL,NULL, &p_inputs_list, 0,                 NULL,NULL,NULL},
  {"Outputs", 'O',NULL,NULL, &p_outputs_list, 0,                NULL,NULL,NULL},
  {"Help   ", 'H',NULL,NULL, HelpMenu,     XtNumber(HelpMenu),  NULL,NULL,NULL}
};

#endif /* xmtv_menu_h_INCLUDED */
