/*
** File:
**
**   plxv_debug.h --- Macros to produce debugging and error messages for 
**                    Parallax Graphics device drivers.
**                    Debugging may be turned off at compile time by failing
**                    to define PLXV_DIAG. Note that changing the value of 
**                    PLXV_DIAG may be used to provide up to 32 different
**                    debugging message enables.
**
** Author:
**
**   Andy Goodrich (Parallax)
**
** Revisions:
**
**   10.28.94 Andy Goodrich
**     - Initial Definition.
**
*/

#ifndef plxvdebug_INCLUDED
#define plxvdebug_INCLUDED
/*
 *  DEBUGGING AND ERROR MACROS
 */
#ifdef PLXV_DIAG
#   define DEBUGF( level, args ) \
    {\
        if ( level & PLXV_DIAG ) \
        { \
            printf args; \
        } \
    }
#else  /* !PLXV_DIAG */
#   define DEBUGF( level, args )
#endif /* PLXV_DIAG */

#endif  /* plxvdebug_INCLUDED */
