/*
 *  parse_value.h: Definitions for parse_value facility.
 *
 *  CONVENTIONS:
 *    (1) Tab stops every 4 characters.
 *    (2) Routines are arranged in alphabetical order within file.
 *    (3) Variables are declared in alphabetical order within routines.
 *
 *  REVISION HISTORY:
 *     19 July 93 - Andy Goodrich
 *        - Initial coding
 *
 *  Copyright(c) 1993, Andrew C. Goodrich
 *  Used with permission by Parallax Graphics, Inc.
 */
#ifndef parse_value_h_INCLUDED
#define parse_value_h_INCLUDED
typedef union _PV_Result {		/* Result of p_value call: */
	int	   i;					/* ... value if integer parsed. */
	float  d;					/* ... value if floating point parsed. */
	char  *p;					/* ... value if character string parsed. */
} PV_Result;

enum {					/* Return values for p_value: */
	PV_Bad_Alloc = 0,	/* Unable to allocate storage for value. */
	PV_Bad_Value,		/* Unable to parse input string. */
	PV_Float,			/* Parsed floating point number. */
	PV_Integer,			/* Parsed integer value. */
	PV_Keyword,			/* Parsed keyword string. */
	PV_Quoted_String,	/* Parsed quoted string. */
};

#endif  /* parse_value_h_INCLUDED */
