/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log:   /plxhp/dave/pvcsrc/include/archives/plxv_xpoint.h_v  $
 * 
 *    Rev 1.1   09 Sep 1996 10:32:48   dave
 * Initial revision
 * Revision 1.1  1995/06/02 12:09:43  dist
 * Initial revision
 *
 * Revision 1.4  91/08/20  20:32:53  mears
 * added loopback values
 * 
 * Revision 1.3  91/08/09  16:53:12  mears
 * added port values
 * 
 * Revision 1.2  91/07/26  19:24:23  eric
 * new from bill
 * 
 * Revision 1.1  91/06/12  16:18:19  eric
 * Initial revision
 * 
 *
 */

#ifndef plxv_xpoint_h_INCLUDED
#define plxv_xpoint_h_INCLUDED

#ifdef H_ID
#ifndef lint
static char *rcsid_plxv_xpoint_h = "@(#)$Id: plxv_xpoint.h,v 1.1 1995/06/02 12:09:43 dist Exp $ Parallax Graphics Inc";
#endif
#endif

/* XPOINT SWITCH DEFINITIONS */
/* these definitions are passed to plxv_xpoint[a,b,c,d] */
#define OUTPUT_EN_DATA	0x00040404
#define OUTPUT_EN_CTL	0x00000008
#define CE_HIGH		0x00000010	/* A, B & C ONLY  !!!!  */
#define HSYNC_HIGH	0x00000020	/* A, B & C ONLY  !!!!  */
#define ODD_HIGH	0x00000040	/* A, B & C ONLY  !!!!  */
#define OUTPUT_EN_CLK	0x00000080	/* A AND B ONLY !!!!! */
#define C_XOR_PIXPHASE  0x00000080	/* C ONLY       !!!!! */
#define VSYNC_HIGH	0x00002000
#define SHUTTLE_EN	0x00004000
#define ODD_OUTMODE_F	0x00000000	/* echo the   filtered odd signal */
#define ODD_OUTMODE_U	0x04000000	/* echo the unfiltered odd signal */
#define ODD_OUTMODE_0	0x08000000	/* output 0 */
#define ODD_OUTMODE_1	0x0c000000	/* output 1 */
#define ODD_INMODE_A	0x00000000	/* sample @ leading edge vsync */
#define ODD_INMODE_B	0x04000000	/* sample @ trailing edge vsync */
#define ODD_INMODE_0	0x08000000	/* input 0 */
#define ODD_INMODE_1	0x0c000000	/* input 1 */

#define A_DATA_OUTPUT_W	0x0
#define A_DATA_OUTPUT_B	0x00010101
#define A_DATA_OUTPUT_C	0x00020202
#define A_DATA_OUTPUT_D	0x00030303

#define A_CLK_OUTPUT_XX	0x00000000
#define A_CLK_OUTPUT_B	0x00000800
#define A_CLK_OUTPUT_C	0x00001000
#define A_CLK_OUTPUT_D	0x00001800

#define A_CTL_OUTPUT_XX 0x00000000
#define A_CTL_OUTPUT_B	0x01000000
#define A_CTL_OUTPUT_C	0x02000000
#define A_CTL_OUTPUT_D	0x03000000

#define B_DATA_OUTPUT_A	0x00000000
#define B_DATA_OUTPUT_W	0x00010101
#define B_DATA_OUTPUT_C	0x00020202
#define B_DATA_OUTPUT_D	0x00030303

#define B_CLK_OUTPUT_A 	0x00000000
#define B_CLK_OUTPUT_XX 0x00000800
#define B_CLK_OUTPUT_C	0x00001000
#define B_CLK_OUTPUT_D	0x00001800

#define B_CTL_OUTPUT_A  0x00000000
#define B_CTL_OUTPUT_XX	0x01000000
#define B_CTL_OUTPUT_C	0x02000000
#define B_CTL_OUTPUT_D	0x03000000

#define C_DATA_OUTPUT_A	0x00000000
#define C_DATA_OUTPUT_B 0x00010101
#define C_DATA_OUTPUT_W	0x00020202
#define C_DATA_OUTPUT_D	0x00030303

#define C_CLK_OUTPUT_A 	0x00000000
#define C_CLK_OUTPUT_B  0x00000800
#define C_CLK_OUTPUT_XX	0x00001000
#define C_CLK_OUTPUT_D	0x00001800

#define C_CTL_OUTPUT_A  0x00000000
#define C_CTL_OUTPUT_B 	0x01000000
#define C_CTL_OUTPUT_XX	0x02000000
#define C_CTL_OUTPUT_D	0x03000000

#define D_CE_HIGH	0x00101010	/* D ONLY  */
#define D_SYNC_HIGH	0x00202020	/* D ONLY  */
#define D_ODD_LOW	0x00404040	/* D ONLY  */
#define D_CLK_LOW	0x00808080	/* D ONLY  */


/* these definitions used ONLY in plxv_xpoint_[v,w] */
/* should not be used by anybody else 		    */
/*   V and W as inputs   */
#define SEL_DATA_INPUT_A	0x00000000
#define SEL_DATA_INPUT_B	0x00010101
#define SEL_DATA_INPUT_C	0x00020202
#define SEL_DATA_INPUT_D	0x00030303

#define SEL_CTL_INPUT_A		0x00000000
#define SEL_CTL_INPUT_B		0x00040404
#define SEL_CTL_INPUT_C		0x00080808
#define SEL_CTL_INPUT_D		0x000c0c0c

#define SEL_CLK_INPUT_A		0x00000000
#define SEL_CLK_INPUT_B		0x00101010
#define SEL_CLK_INPUT_C		0x00202020
#define SEL_CLK_INPUT_D		0x00303030

#define SEL_CLK_HIGH		0x00404040

/* these input are passed to plxv_xpoint_[v,w] */
#define PORT_A 0
#define PORT_B 1
#define PORT_C 2
#define PORT_D 3
#define LOOPBACK 4
#define INPUT_A	0
#define INPUT_B	1
#define INPUT_C	2
#define INPUT_D	3
#define OUTPUT_A  4
#define OUTPUT_B  5
#define OUTPUT_C 6
#define OUTPUT_LOOPBACK_B 7
#define INPUT_LOOPBACK_B 8
#define OUTPUT_LOOPBACK_A 9
#define INPUT_LOOPBACK_A 10

#endif  /* plxv_xpoint_h_INCLUDED */
