/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log:	c3.h,v $
 * Revision 1.2  93/06/18  17:00:14  xan
 * Rtv merge, added RTV_OPEN_BIT, does this belong here...oh well
 * 
 * Revision 1.1  91/07/26  20:05:26  eric
 * Initial revision
 * 
 *
 */

#ifdef H_ID
#ifndef lint
static char *rcsid_c3_h = "@(#)$Id: c3.h,v 1.2 93/06/18 17:00:14 xan Exp $ Parallax Graphics Inc";
#endif
#endif

#define OPEN_RTV_BIT 0x100000     /* for field mode */

#ifdef C3TRACE
#define C3_WREG(dst,src) 						\
	 { c3_wreg->dst = src;						\
	if (c3_trace) printf("W: %16.16s = %.8x @ %4.4x\n","dst",src,	\
			(int) &c3_wreg->dst - (int) c3_wreg); }

#define C3_RREG(dst,src) { dst = c3_rreg->src;				\
	if (c3_trace) printf("R: %16.16s = %.8x @ %4.4x\n","src",dst,	\
			(int) &c3_rreg->src - (int) c3_rreg); }
#else
#define	ORIG_C3_WREG(dst,src)  c3_wreg->dst = src; 
#endif

#ifdef XVDIAG

define	c3wr(dst,src) c3_wreg->dst = src;

define 	c3rr(dst,src) dst = c3_rreg->src;

define	c3prr(src) printf("%x\n",c3_rreg->src);

#endif

typedef struct {
#ifdef C3PIO
	unsigned short Codec;
	unsigned short unused_99;
#else
	unsigned Codec;
#endif

	unsigned unused_1[0x1fff];

	unsigned HPeriod;
	unsigned HSync;
	unsigned HDelay;
	unsigned HActive;
	unsigned VPeriod;
	unsigned VSync;
	unsigned VDelay;
	unsigned VActive;

	unsigned unused_2[0x1f8];

	unsigned DCT[8];	
	unsigned Init_5;		/* DCT core Sync */
	unsigned Init_6;		/* DCT Cntl, test */
	
	unsigned unused_3[0x1f6];

	unsigned Config;
	unsigned Huff_Enable;
	unsigned S_reset;
	unsigned Start;
	unsigned HV_Enable;
	unsigned Flags;
	unsigned NMRQ_Enable;
	unsigned DRQ_Enable;
	unsigned StartFrame;

	/* 	unsigned Version;	 READONLY */

	unsigned unused_4[0x1f7];

	unsigned Init_1;
	unsigned Init_2;

	unsigned unused_5[0x1fe];

	unsigned CodecSeq;
	unsigned CodecCompH;
	unsigned CodecCompL;
	unsigned CoderAttr;
	unsigned CodingIntH;
	unsigned CodingIntL;

	unsigned unused_21[0x1fd];

	unsigned DecLength;

	/*	unsigned DecMarker;  	 READONLY */

	unsigned unused_6;

	unsigned DecResume;
	unsigned DecDPCM;
	unsigned CodeOrder;

	unsigned unused_7[0x378];

	unsigned Init_3;

	unsigned unused_8[0x7f];

	unsigned QuantA[128];	
	unsigned QuantB[128];

	unsigned QuantSelect;

	unsigned unused_10[0x7f];

	unsigned QuantSync;

	unsigned unused_11;

	unsigned QuantYC;
	unsigned QuantAB;

	unsigned unused_12[0x7c];

	unsigned R2Y;		/* RGB TO YUV TRANSFORMATION MATRIX */ 
	unsigned G2Y; 
	unsigned B2Y;
	unsigned R2U;
	unsigned G2U;
	unsigned B2U;
	unsigned R2V;
	unsigned G2V;
	unsigned B2V;

	unsigned unused_13[0x3];

	unsigned VideoLatency;
	unsigned HControl;
	unsigned VControl;

	/*	unsigned VertLineCount;	 READONLY */
	/* 	unsigned Block;		 READONLY (undocumented) */ 
	/*	unsigned BlockAddress;   READONLY (undocumented) */

	unsigned unused_14[0x3b1];

	unsigned Init_4;		/* Block Storage Sync */

	unsigned unused_15[0x13f];

	unsigned Init_7;		/* DCT MEMORY (undocumented) */

	unsigned unused_16[0xff];

	unsigned FIFO[128];	

	unsigned unused_17[0x180];

	unsigned HuffYAC[704];

	unsigned unused_18[0x40];

	unsigned HuffYDC[32];

	unsigned unused_19[0xe0];

	unsigned HuffCAC[704];

	unsigned unused_20[0x40];

	unsigned HuffCDC[32];

} C3_WREGS;

typedef struct {
#ifdef C3PIO
	unsigned short Codec;
	unsigned short unused_99;
#else
	unsigned Codec;
#endif
	unsigned unused_1[0x1fff];

	unsigned HPeriod;
	unsigned HSync;
	unsigned HDelay;
	unsigned HActive;
	unsigned VPeriod;
	unsigned VSync;
	unsigned VDelay;
	unsigned VActive;

	unsigned unused_2[0x1f8];

	unsigned DCT[8];	
	unsigned Init_5;		/* DCT core Sync */
	unsigned Init_6;		/* DCT Cntl, test */
	
	unsigned unused_3[0x1f6];

	unsigned Config;
	unsigned Huff_Enable;
	unsigned S_reset;
	unsigned Start;
	unsigned HV_Enable;
	unsigned Flags;
	unsigned NMRQ_Enable;
	unsigned DRQ_Enable;
	unsigned StartFrame;

	unsigned Version;

	unsigned unused_4[0x5f9];

	/* 	unsigned Init_1;	WRITE ONLY...
		unsigned Init_2;

		unsigned CodecSeq;
		unsigned CodecCompH;
		unsigned CodecCompL;
		unsigned CoderAttr;
		unsigned CodingIntH;
		unsigned CodingIntL;
	*/

	unsigned DecLength;
	unsigned DecMarker; 

	unsigned unused_5[2];

	/*	unsigned DecResume;	WRITE ONLY...
		unsigned DecDPCM;
	*/

	unsigned CodeOrder;

	unsigned unused_7[0x378];

	unsigned Init_3;

	unsigned unused_8[0x7f];

	unsigned QuantA[128];
	unsigned QuantB[128];	

	/*	unsigned QuantSelect;	WRITE ONLY */

	unsigned unused_10[0x80];

	unsigned QuantSync;

	unsigned unused_11[3];

	/*	unsigned QuantYC;	WRITE ONLY...
		unsigned QuantAB;
	*/

	unsigned unused_12[0x7c];

	unsigned R2Y;		/* RGB TO YUV TRANSFORMATION MATRIX */ 
	unsigned G2Y; 
	unsigned B2Y;
	unsigned R2U;
	unsigned G2U;
	unsigned B2U;
	unsigned R2V;
	unsigned G2V;
	unsigned B2V;

	unsigned unused_13[0x3];

	unsigned VideoLatency;
	unsigned HControl;
	unsigned VControl;
	unsigned VertLineCount;

	unsigned unused_22[0x1f0];

	unsigned Block;	 		/* undocumented */

	unsigned unused_23[0x17f];

	unsigned BlockAddress;   	/* undocumented */

	unsigned unused_14[0x3f];

	unsigned Init_4;		/* Block Storage Sync */

	unsigned unused_15[0x13f];

	unsigned Init_7;		/* DCT MEMORY (undocumented) */

	unsigned unused_16[0xff];

	unsigned FIFO[128];	

	unsigned unused_17[0x180];

	unsigned HuffYAC[704];

	unsigned unused_18[0x40];

	unsigned HuffYDC[32];

	unsigned unused_19[0xe0];

	unsigned HuffCAC[704];

	unsigned unused_20[0x40];

	unsigned HuffCDC[32];

} C3_RREGS;





/* Flags bits */

#define _Flags_FIFO_NotFull	0x00008000L
#define _Flags_FIFO_NotEmpty	0x00004000L
#define _Flags_Codec_RegBusy	0x00002000L
#define _Flags_BusError		0x00001000L
#define _Flags_MarkerCode	0x00000800L
#define _Flags_VSync		0x00000400L
#define _Flags_VInactive	0x00000200L
#define _Flags_Field0		0x00000100L
#define _Flags_FIFO_Empty	0x00000080L
#define _Flags_FIFO_QFull	0x00000040L
#define _Flags_FIFO_HalfFull	0x00000020L
#define _Flags_FIFO_3QFull	0x00000010L
#define _Flags_FIFO_NotQFull	0x00000008L
#define _Flags_FIFO_NotHalfFull	0x00000004L
#define _Flags_FIFO_Not3QFull	0x00000002L
#define _Flags_FIFO_Late	0x00000001L

/* Interrupt bits */

#define _Int_FIFO_NotFull	0x00008000L
#define _Int_FIFO_NotEmpty	0x00004000L
#define _Int_Codec_RegBusy	0x00002000L
#define _Int_BusError		0x00001000L
#define _Int_MarkerCode		0x00000800L
#define _Int_VSync		0x00000400L
#define _Int_VInactive		0x00000200L
#define _Int_FrameEnd		0x00000100L
#define _Int_FIFO_Empty		0x00000080L
#define _Int_FIFO_QFull		0x00000040L
#define _Int_FIFO_HalfFull	0x00000020L
#define _Int_FIFO_3QFull	0x00000010L
#define _Int_FIFO_NotQFull	0x00000008L
#define _Int_FIFO_NotHalfFull	0x00000004L
#define _Int_FIFO_Not3QFull	0x00000002L
#define _Int_FIFO_Late		0x00000001L

/* Status bits */

#define _Status_DRQ		0x80000000L
#define _Status_BLANK		0x40000000L
#define _Status_HSYNC		0x20000000L
#define _Status_VSYNC		0x10000000L

/* Configuration bits */

#define _Configuration_HSYNC	0x20000000L
#define _Configuration_VSYNC	0x10000000L
#define _Configuration_NOSYNC	0x00000000L

/* Read/write permission */

/* Control bits */										

#define _Control_Addr32		0x00000000L
#define _Control_Addr16		0x01000000L
#define _Control_Slave		0x00000000L
#define _Control_Master		0x02000000L
#define _Control_Data32		0x00000000L
#define _Control_Data16		0x04000000L
#define _Control_Reset0		0x00000000L
#define _Control_Reset1		0x80000000L

#define RR 1
#define WW 2
#define RW 3
#define DF 7

/* Error codes */

#define NoError		0
#define YesError	1
#define BusError	2
#define FileError	3
#define LogicalError	4
#define MemError	5

#ifdef XVDIAG

C3_WREGS *c3_wreg;
C3_RREGS *c3_rreg;

{
xv_open_slot();
c3_wreg = c3_rreg = xv_c3map();
}
#endif

