/*
 * Copyright (c) 1993 Parallax Graphics Inc.
 */

#ifndef _C3REG_H_
#define _C3REG_H_

#pragma ident "@(#)c3regs.h	1.4 Copyright (c) 1993 Parallax Graphics Inc"

#include <sys/types.h>

typedef struct {
	u_int Codec[0x2000];	/* 0x0000 */

	u_int HPeriod;		/* 0x8000 */
	u_int HSync;
	u_int HDelay;
	u_int HActive;
	u_int VPeriod;
	u_int VSync;
	u_int VDelay;
	u_int VActive;

	u_int unused_1[0x1f8];

	u_int DCT[8];		/* 0x8800 */
	u_int Init_5;		/* DCT core Sync */
	u_int Init_6;		/* DCT Cntl, test */
	
	u_int unused_2[0x1f6];

	u_int Config;		/* 0x9000 */
	u_int Huff_Enable;
	u_int S_reset;
	u_int Start;
	u_int HV_Enable;
	u_int Flags;
	u_int NMRQ_Enable;
	u_int DRQ_Enable;
	u_int StartFrame;
	u_int Version;		/* READONLY */

	u_int unused_3[0x1f7];

	u_int Init_1;		/* 0x9800 */
	u_int Init_2;

	u_int unused_4[0x1fe];

	u_int CodecSeq;		/* 0xA000 */
	u_int CodecCompH;
	u_int CodecCompL;
	u_int CoderAttr;
	u_int CodingIntH;
	u_int CodingIntL;

	u_int unused_5[0x1fd];

	u_int DecLength;	/* 0xA8c0 */
	u_int DecMarker;  	/* READONLY */
	u_int :32;
	u_int DecResume;
	u_int DecDPCM;
	u_int CodeOrder;

	u_int unused_6[0x378];

	u_int Init_3;		/* 0xB600 */

	u_int unused_7[0x7f];

	u_int QuantA[128];	/* 0xB800 */
	u_int QuantB[128];
	u_int QuantSelect;

	u_int unused_8[0x7f];

	u_int QuantSync;	/* 0xBE00 */
	u_int :32;
	u_int QuantYC;
	u_int QuantAB;

	u_int unused_9[0x7c];

	u_int R2Y;	/* 0xRGB TO YUV TRANSFORMATION MATRIX */ 
	u_int G2Y; 
	u_int B2Y;
	u_int R2U;
	u_int G2U;
	u_int B2U;
	u_int R2V;
	u_int G2V;
	u_int B2V;

	u_int unused_10[0x3];

	u_int VideoLatency;	/* 0xC030 */
	u_int HControl;
	u_int VControl;
	u_int VertLineCount;	/* READONLY */
	u_int Block;		/* READONLY (undocumented) */ 
	u_int BlockAddress;	/* READONLY (undocumented) */

	u_int unused_11[0x3b1];

	u_int Init_4;		/* 0xCF00 Block Storage Sync */

	u_int unused_12[0x13f];

	u_int Init_7;		/* 0xD400 DCT MEMORY (undocumented) */

	u_int unused_13[0xff];

	u_int FIFO[128];	/* 0xD800 */

	u_int unused_14[0x180];

	    struct {		/* 0xE000 */
		u_int YAC[704];
		u_int unused_yac[0x40];
		u_int YDC[32];
		u_int unused_ydc[0xe0];
		u_int CAC[704];
		u_int unused_cac[0x40];
		u_int CDC[32];
	    } Huffman;
	u_int unused_15[0xdc];

} C3_regs;

/* Flags & Interrupt bits (registers are identical on CL550) */

#define C3_FIFO_NotFull		0x00008000L
#define C3_FIFO_NotEmpty	0x00004000L
#define C3_Codec_RegBusy	0x00002000L
#define C3_BusError		0x00001000L
#define C3_MarkerCode		0x00000800L
#define C3_VSync		0x00000400L
#define C3_VInactive		0x00000200L
#define C3_FrameEnd		0x00000100L
#define C3_FIFO_Empty		0x00000080L
#define C3_FIFO_QFull		0x00000040L
#define C3_FIFO_HalfFull	0x00000020L
#define C3_FIFO_3QFull		0x00000010L
#define C3_FIFO_NotQFull	0x00000008L
#define C3_FIFO_NotHalfFull	0x00000004L
#define C3_FIFO_Not3QFull	0x00000002L
#define C3_FIFO_Late		0x00000001L

#define _Int_FIFO_NotFull	0x00008000L
#define _Int_FIFO_NotEmpty	0x00004000L
#define _Int_Codec_RegBusy	0x00002000L
#define _Int_BusError		0x00001000L
#define _Int_MarkerCode		0x00000800L
#define _Int_VSync		0x00000400L
#define _Int_VInactive		0x00000200L
#define _Int_FrameEnd		0x00000100L
#define _Int_FIFO_Empty		0x00000080L
#define _Int_FIFO_QFull		0x00000040L
#define _Int_FIFO_HalfFull	0x00000020L
#define _Int_FIFO_3QFull	0x00000010L
#define _Int_FIFO_NotQFull	0x00000008L
#define _Int_FIFO_NotHalfFull	0x00000004L
#define _Int_FIFO_Not3QFull	0x00000002L
#define _Int_FIFO_Late		0x00000001L

/* Status bits */


#define C3_Status_DRQ			0x80000000L
#define C3_Status_BLANK			0x40000000L
#define C3_Status_HSYNC			0x20000000L
#define C3_Status_VSYNC			0x10000000L

/* Configuration bits */

#define C3_Configuration_HSYNC		0x20000000L
#define C3_Configuration_VSYNC		0x10000000L
#define C3_Configuration_NOSYNC		0x00000000L

/* Read/write permission */

/* Control bits */										
#define C3_Control_Addr32		0x00000000L
#define C3_Control_Addr16		0x01000000L
#define C3_Control_Slave		0x00000000L
#define C3_Control_Master		0x02000000L
#define C3_Control_Data32		0x00000000L
#define C3_Control_Data16		0x04000000L
#define C3_Control_Reset0		0x00000000L
#define C3_Control_Reset1		0x80000000L


#ifdef TRACE
#define C3_WRITE_TRACE(regs, dst, src) cmm_err(CE_CONT, "C3_WREG(dst,src)\n"),
#define C3_READ_TRACE(regs, src) cmn_err(CE_CONT, "C3_RREG(dst,src)\n"),
#else
#define C3_WRITE_TRACE(regs, dst, src)
#define C3_READ_TRACE(regs, src)
#endif

#define C3_WREG(regs, dst, src)				\
	(C3_WRITE_TRACE(regs, dst, src)			\
	(regs)->c3->dst =   (src)			\
	)

#define C3_RREG(regs, src)				\
	(C3_READ_TRACE(regs, src)			\
	(regs)->c3->src					\
	)

/***************XV's CCube Command register values************/
#ifdef mips
#define C3_INDIAN (0)
#else
#define C3_INDIAN (0x4000000)
#endif
/*
 * for reading c3
 */
#define XVC3_RESET_TO_PIO (0)
#define XVC3_START_DMA_TO_HOST_1   (0x1010119 | C3_INDIAN)
#define XVC3_START_DMA_TO_HOST_2   (0x0050545 | C3_INDIAN)
#define XVC3_PAUSE_DMA_TO_HOST     (0x1050545 | C3_INDIAN)
#define XVC3_PURGE_BIC_GO_PIO	   (0x1040465)
#define XVC3_CONT_DMA_TO_HOST_1	   (0x1050511 | C3_INDIAN)
#define XVC3_CONT_DMA_TO_HOST_2	   (XVC3_START_DMA_TO_HOST_2)
#define XVC3_PURGE_C3_CONT_DMA	   (0x2050545 | C3_INDIAN)

/*
 *for writing c3
 */
#define XVC3_START_DMA_FROM_HOST_1 (0x102021a | C3_INDIAN)
#define XVC3_START_DMA_FROM_HOST_2 (0x0060646 | C3_INDIAN)
#define XVC3_PAUSE_DMA_FROM_HOST   (0x0060642 | C3_INDIAN)
#define XVC3_WRITE_GO_PIO	   (0x0040402) /* Bob change */
#define XVC3_CONT_DMA_FROM_HOST_1  (0x0060602 | C3_INDIAN)
#define XVC3_CONT_DMA_FROM_HOST_2  (XVC3_START_DMA_FROM_HOST_2)

/*
 * stall conditions
 */
#define STALL_ALWAYS	0
#define STALL_NH_O_FE	1
#define STALL_NH_O_NFE	2
#define STALL_NH	3
#define STALL_H_O_FE	4
#define STALL_FE	5
#define STALL_H_XO_NFE	6
#define STALL_NH_FE	7
#define STALL_H_O_NFE	8
#define STALL_H_XO_FE	9
#define STALL_NFE	10
#define STALL_NH_NFE	11
#define STALL_H		12
#define STALL_H_FE	13
#define STALL_H_NFE	14
#define STALL_NEVER	15

#define	STATE0	0		/* Done or idle state			  */
#define STATEW1	0x81		/* Write started, waiting for FIFO 3QFull */
				/* or end of buffer.			  */
#define	STATEW2	0x82		/* Write started, waiting for FIFO empty  */
#define STATEW3	0x83
#define STATEWW 0x84

#define	STATER1	1		/* Read started, waiting for FIFO QFull	  */
				/* or video pipeline inactive.		  */
#define	STATER2	2		/* Read started, waiting for FIFO empty	  */
#define STATERW 3		/* Read finished, waiting for V intr */
#define STATEDN 4		/* transfers finished, waiting for FLAG& intr */
#define STATEW 	0x80		/* Bit indicating a write state		  */
#define STATE_ERR ((u_int)-1)

#define C3_ON ((u_int)0xffffffff)
#define C3_OFF (0)
#endif
