/*
 * Copyright (c) 1993 Parallax Graphics Inc.
 */


#include <sys/types.h>

typedef struct {

	u_int HPeriod;		/* 0x8000 */
	u_int HSync;
	u_int HDelay;
	u_int HActive;
	u_int VPeriod;
	u_int VSync;
	u_int VDelay;
	u_int VActive;


	u_int DCT[8];		/* 0x8800 */
	u_int Init_5;		/* DCT core Sync */
	u_int Init_6;		/* DCT Cntl, test */
	

	u_int Config;		/* 0x9000 */
	u_int Huff_Enable;
	u_int S_reset;
	u_int Start;
	u_int HV_Enable;
	u_int Flags;
	u_int NMRQ_Enable;
	u_int DRQ_Enable;
	u_int StartFrame;
	u_int Version;		/* READONLY */


	u_int Init_1;		/* 0x9800 */
	u_int Init_2;


	u_int CodecSeq;		/* 0xA000 */
	u_int CodecCompH;
	u_int CodecCompL;
	u_int CoderAttr;
	u_int CodingIntH;
	u_int CodingIntL;


	u_int DecLength;	/* 0xA8c0 */
	u_int DecMarker;  	/* READONLY */
	u_int :32;
	u_int DecResume;
	u_int DecDPCM;
	u_int CodeOrder;


	u_int Init_3;		/* 0xB600 */


	u_int QuantA[128];	/* 0xB800 */
	u_int QuantB[128];
	u_int QuantSelect;


	u_int QuantSync;	/* 0xBE00 */
	u_int :32;
	u_int QuantYC;
	u_int QuantAB;


	struct {		/* 0xC000 */
		u_int R2Y;	/* 0xRGB TO YUV TRANSFORMATION MATRIX */ 
		u_int G2Y; 
		u_int B2Y;
		u_int R2U;
		u_int G2U;
		u_int B2U;
		u_int R2V;
		u_int G2V;
		u_int B2V;
	} CTM;


	u_int VideoLatency;	/* 0xC030 */
	u_int HControl;
	u_int VControl;
	u_int VertLineCount;	/* READONLY */
	u_int Block;		/* READONLY (undocumented) */ 
	u_int BlockAddress;	/* READONLY (undocumented) */


	u_int Init_4;		/* 0xCF00 Block Storage Sync */


	u_int Init_7;		/* 0xD400 DCT MEMORY (undocumented) */


	u_int FIFO[128];	/* 0xD800 */

	u_int HuffYAC[704];
	u_int unused_yac[0x40];
	u_int YDC[32];
	u_int unused_ydc[0xe0];
	u_int CAC[704];
	u_int unused_cac[0x40];
	u_int CDC[32];

} c3shdw;
