#ifdef _KERNEL
#include "rtv.h"
typedef struct {
	int ready;
	FIELD_INFO field[2];
	caddr_t  ccube_in;
	ksema_t  sema_lock;		/* Semaphore locking object */
	}RECORD_FRAME_INFO;

typedef struct {
	int ready;
	FIELD_INFO field[2];
	caddr_t  ccube_out;
	ksema_t  sema_lock;		/* Semaphore locking object */
	}PLAY_FRAME_INFO;

typedef struct {
	FIELD_INFO		*head;
	FIELD_INFO		*tail;
	FIELD_INFO    		*input;
	FIELD_INFO    		*output;
	FIELD_INFO		que[MAX_FIELD_QUE_SIZE];
	int			level;
	}QUEUE_INFO;

typedef struct {
	int	    		interlace;
	int			field_no;
	int	 		offset;
	int	    		que_level_in[4];
	int	    		que_level_out[4];
	int			*rq;
	int			*wq;
	int			*aud_rq;
	int			*aud_wq;
	int			*net_rq;
	int			*net_wq;
	u_int			clock_time;
	u_int			audio_sync;
	caddr_t  		dma_in_addr;
	int	 		dma_in_offset;
	caddr_t  		dma_out_addr;
	int	 		dma_out_offset[4];
	int			max_shm_size;
	int		        play_action;
	int			record_qlevel;
	int			record_action;
	int			stream_active[4];
	int			host_id_tbl[4];
	int			recv_ready[4];
	QUEUE_INFO		playback_streams[4];
	FIELD_INFO    		record_que[MAX_FIELD_QUE_SIZE];
	FIELD_INFO		*record_head;
	FIELD_INFO		*record_tail;
	FIELD_INFO		*record_input;
	FIELD_INFO		*record_output;
	ksema_t     		send_lock;	/* Semaphore locking object */
	ksema_t     		sema_lock;	/* Semaphore locking object */
	int			audio_late;
	int			frame_rate;
	int			stream_id;
	int			put_trigger;
	int			get_trigger;
	ddi_softintr_t		ramdisk_put_trig;
	ddi_softintr_t		ramdisk_get_trig;
	int			audio_mode;
	int			current_audio_stream;
	int			*audio_shm;
	int			audio_monitor;
	}SHM_FIELD_QUE;


#endif
