/*
 * Copyright (c) 1993 Parallax Graphics Inc.
 */

#pragma ident "@(#)ccube_decomp.c 1.6 Copyright (c) 1993 Parallax Graphics Inc"


#include <sys/types.h>
#include <sys/param.h>
#include <sys/cred.h>
#include <sys/errno.h>
#include <sys/cmn_err.h>
#include <sys/open.h>
#include <sys/file.h>
#include <sys/kmem.h>
#include <sys/t_lock.h>
#include <sys/stat.h>
#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/sunddi.h>

#include "tvtwo.h"
#define DECOMPRESSION_TABLES
#include "qfact.h"
#include "huff.h"
/*
#define TRACE_DECOMP_TIME
#define TIME_DECOMPRESSION
#define TRACE_PUT_NEXT
#define AUDIO_SYNC_CONTROL
*/
#define RAMDISK_SUPPORT
#define CCUBE_STATE_TIMEOUT 1
#define MAX_FRAME_TIME 3000
#define MIN_DECOMP_TIME 700
#define MIN_WAIT_TIME (MIN_DECOMP_TIME*11)
static int flds_per_frame[2]= {1,2};



enableC3(tvtwo_softc *softc)
{
    C3_WREG(softc->regs, HV_Enable, C3_ON);
    C3_WREG(softc->regs, HV_Enable, C3_OFF);
    C3_WREG(softc->regs, HV_Enable, C3_ON);
    C3_WREG(softc->regs, Start, C3_OFF);
}
put_next_field(tvtwo_softc *softc)
{
ddi_dma_cookie_t dma_cookie;
QUEUE_INFO *playback_qinfo;
FIELD_INFO *field ;
static int sid,start_pixel;
register int compare,overflow;
static int mask=0x3f;
static int video_offset;
static int trace=0;
SHM_FIELD_QUE *shm_que = (SHM_FIELD_QUE *)softc->shm_que;

        mutex_enter(&softc->rtv_dma_lock);
        if(softc->rtv_dma_busy)
            cv_wait(&softc->rtv_dma_done,&softc->rtv_dma_lock);
        softc->rtv_dma_busy=1;
        mutex_exit(&softc->rtv_dma_lock);
        softc->rtv_dma_state=PLAY;

        softc->ccube_comp_state=DST_BUSY;
        sid  = softc->stream_id;
    /*
     *  retreive playback_que field info. 
     */
        playback_qinfo= (QUEUE_INFO *)&shm_que->playback_streams[sid];
    /*
     *  Skip oldest frame in queue if size greater than 20 fields.
     */
#ifdef OVERFLOW_CONTROL
        field= playback_qinfo->output;
        if(field->polarity==0 && if(playback_qinfo->level>32)
        {
            if(playback_qinfo->output!=playback_qinfo->input)
            {
                playback_qinfo->output+=8;
                playback_qinfo->level-=8;
                if(playback_qinfo->output>=playback_qinfo->tail)
                     playback_qinfo->output=playback_qinfo->head;
            }
        }
#endif
#ifdef NETWORK_AUDIO_SYNC_CONTROL
        field= playback_qinfo->output;
        video_offset=flds_per_frame[softc->interlace];
        if(playback_qinfo->level>video_offset)
        {
             if(shm_que->audio_mode==PLAY && field->polarity==0)
         { 
                 if(field->clock+video_offset < shm_que->audio_sync) 
                 {
            /*
                       if(playback_qinfo->output!=playback_qinfo->input)
                {
                            playback_qinfo->output+=2;
                        playback_qinfo->level-=2;
                            if(playback_qinfo->output>=playback_qinfo->tail)
                            playback_qinfo->output=playback_qinfo->head;
                    }
             */
             }
         }
        }
#endif
        field= playback_qinfo->output;
        softc->field_size= field->size;
        softc->field_offset[1]= field->offset;
        softc->field_polarity= field->polarity;
        field->inuse=0;

        softc->play_wintbl[sid].current_rate=softc->field_size;
        field= (FIELD_INFO *)playback_qinfo->output;
        ccube_load_decomp_tables(softc,field);
        /*
         * Retrieve dma cookie address and xfer size.
         */
#ifdef DUAL_DMA
        if (ddi_dma_htoc(softc->ccube_write_dma,
                 softc->field_offset[1],&dma_cookie) != DDI_SUCCESS) 
#else
        if (ddi_dma_htoc(softc->ccube_read_dma,
                 softc->field_offset[1],&dma_cookie) != DDI_SUCCESS) 
#endif
        {
        cmn_err(CE_PANIC,"ccube %d: ddi_dma_htoc failed",
            ddi_get_instance(softc->devi));
        }
    /*
     ***** Load dma address and size from dma cookie.
     */
#ifdef DUAL_DMA
        softc->dma_output_addr = (caddr_t)dma_cookie.dmac_address;
#else
        softc->dma_input_addr = (caddr_t)dma_cookie.dmac_address;
#endif
    /*
     ***** Flush memory with respect to device.
     */
#ifdef DUAL_DMA
        (void)ddi_dma_sync(softc->ccube_write_dma,softc->field_offset[1],
               softc->record_size,DDI_DMA_SYNC_FORDEV);
#else
        (void)ddi_dma_sync(softc->ccube_read_dma,softc->field_offset[1],
               softc->record_size,DDI_DMA_SYNC_FORDEV);
#endif
        start_pixel=softc->play_start_pixel[sid];
        SetC3PutImageTiming(softc,softc->play_wintbl[sid].width,
                  softc->play_wintbl[sid].height);

	ccube_wchan_mode(softc,PLAY);
        if(field->polarity==0) 
            XV_WREG(softc->regs,WStartAdd.l,start_pixel);
        else 
            XV_WREG(softc->regs,WStartAdd.l,start_pixel+1152);
        ccube_write(softc);
}
ccube_load_decomp_tables(tvtwo_softc *softc, FIELD_INFO *field)
{
register short qindex; 

     qindex= softc->decomp_qindex= ccube_q_to_index(field->qfactor);
     softc->qtab = (unsigned short *)&CL550Qtable_D[qindex][0];
     softc->htab = defaultCL550DecompHtable;
     C3InitDecompress(softc);
     LoadCL550Qtable(softc,softc->qtab);
     LoadCL550Htable(softc,softc->htab);
     c3_load_dct(softc); 
     enableC3(softc);
}

ccube_finish_decomp(tvtwo_softc *softc)
{
QUEUE_INFO *playback_qinfo;
FIELD_INFO *field ;
SHM_FIELD_QUE *shm_que = (SHM_FIELD_QUE *)softc->shm_que;
CCUBE_INFO *ci = softc->ci;
register int sid,n,wait_time;
static int delta,end_time;
static int trace=0;

/* 
 * DMA completion - Sync dma buffer for cpu access.
 */
#ifdef DUAL_DMA
         (void)ddi_dma_sync(softc->ccube_write_dma,softc->field_offset[1],
         softc->record_size,DDI_DMA_SYNC_FORKERNEL);
#else
         (void)ddi_dma_sync(softc->ccube_read_dma,softc->field_offset[1],
         softc->record_size,DDI_DMA_SYNC_FORKERNEL);
#endif
     /*
      * Wake up mutex
      */
         if(ci->state == CCUBE_STATE_TIMEOUT)
         {
#ifdef NETWORK_SUPPORT
             shm_que->stream_active[0]=0;
             shm_que->stream_active[1]=0;
             shm_que->stream_active[2]=0;
             shm_que->stream_active[3]=0;
#endif
             ccube_init_state(softc);
             softc->Widcount=0;
             softc->rtv_dma_busy=0;
             cv_signal(&softc->rtv_dma_done);
             sid=softc->stream_id;
	     cmn_err(CE_WARN,"! decomp timeout size=%d\n",softc->field_size);
#ifdef NETWORK_SUPPORT
         /*
          * Reset all output queues
          */
             playback_qinfo= (QUEUE_INFO *)&shm_que->playback_streams[0];
             playback_qinfo->output=playback_qinfo->input;
             playback_qinfo->level=0;
             playback_qinfo= (QUEUE_INFO *)&shm_que->playback_streams[1];
             playback_qinfo->output=playback_qinfo->input;
             playback_qinfo->level=0;
             playback_qinfo= (QUEUE_INFO *)&shm_que->playback_streams[2];
             playback_qinfo->output=playback_qinfo->input;
             playback_qinfo->level=0;
             playback_qinfo= (QUEUE_INFO *)&shm_que->playback_streams[3];
             playback_qinfo->output=playback_qinfo->input;
             playback_qinfo->level=0;
#endif
             playback_qinfo= (QUEUE_INFO *)&shm_que->playback_streams[sid];
             if(playback_qinfo->output!=playback_qinfo->input)
             {
                 if(playback_qinfo->level>0)
                 {
                      field= playback_qinfo->output;
                      playback_qinfo->level--;
                      playback_qinfo->output++;
                      if(playback_qinfo->output>=playback_qinfo->tail)
                          playback_qinfo->output=playback_qinfo->head;
                      if(field->polarity==0 && playback_qinfo->level>0)
                      {
                          playback_qinfo->level--;
                          playback_qinfo->output++;
                          if(playback_qinfo->output>=playback_qinfo->tail)
                              playback_qinfo->output=playback_qinfo->head;
                      }
                 }
             }
#ifdef NETWORK_SUPPORT
             shm_que->stream_active[0]=1;
             shm_que->stream_active[1]=1;
             shm_que->stream_active[2]=1;
             shm_que->stream_active[3]=1;
#endif
             softc->field_polarity=0;
	     start_play(softc);
             return;
         }
         else
         {
             softc->rtv_dma_busy=0;
             cv_signal(&softc->rtv_dma_done);
             sid=softc->stream_id;
             playback_qinfo= (QUEUE_INFO *)&shm_que->playback_streams[sid];
             if(playback_qinfo->output!=playback_qinfo->input)
             {
                 if(playback_qinfo->level>0)
                 {
                     playback_qinfo->level--;
                     playback_qinfo->output++;
                     if(playback_qinfo->output>=playback_qinfo->tail)
                     playback_qinfo->output=playback_qinfo->head;
                 }
             }
             if(softc->ccube_comp_state==DST_IOLATE)
             {
                 playback_qinfo= (QUEUE_INFO *)&shm_que->playback_streams[sid];
                 if(playback_qinfo->level>0)
                     put_next_field(softc);
             }
             softc->ccube_comp_state= DST_FIELD_DONE;
         }
}


