/*
 * Copyright (c) 1993 Parallax Graphics Inc.
 */

#pragma ident "@(#)ccube_util.c	1.6 Copyright (c) 1993 Parallax Graphics Inc"

#include <sys/conf.h>
#include "tvtwo.h"
#define _Int_Sbus	0x0008

static void
c3_error(tvtwo_softc *softc, char *message);

void
c3_load_dct(tvtwo_softc *softc);
#define C3_TIMEOUT 1000


int             Dbg_index = 0;
static int             Dbg_first_time = 1;
#define TRACE_STATE_TIME

#ifdef TRACE_STATE_TIME
typedef struct {
		int load;
		int dma;
		}TIME_FLDS;

typedef struct {
		int state;
		int time;
		}STATE_FLDS;
static TIME_FLDS field_time[360];
static STATE_FLDS state_trace[7500];
static field_state[360];
static int delta=0,save_cnt=0;
static int total_time=0;
static int cycle=0;
static int size_history[120];
static int start_time=0;

trace_state(tvtwo_softc *softc,int state,int init)
{
static int end_time;

	if(init==1)
	    start_time = XV_RREG(softc->regs,TmrCnt.l);	
	else
	{
	    end_time = XV_RREG(softc->regs,TmrCnt.l);	
	    delta = end_time-start_time;
	    start_time=end_time;
	    state_trace[save_cnt].state=state;
	    state_trace[save_cnt++].time=delta;
	    if(save_cnt==7500)
	    {
		save_cnt=0;
	    }
	}
	return(delta);
}

set_timer(tvtwo_softc *softc,int mode)
{
register int end_time;
	switch(mode)
	{
	case 0:
	     start_time = XV_RREG(softc->regs,TmrCnt.l);	
	     break;
	case 1:
	     end_time = XV_RREG(softc->regs,TmrCnt.l);	
	     delta = end_time-start_time;
	     field_time[save_cnt].load= delta;
	     start_time=end_time;
	     break;
	case 2:
	     end_time = XV_RREG(softc->regs,TmrCnt.l);	
	     delta = end_time-start_time;
	     field_time[save_cnt++].dma= delta;
	     break;
	}
	if(save_cnt>=120)save_cnt=0;
}
save_field_size(int size)
{
	size_history[cycle++]=size;
	if(cycle>=120)cycle=0;
}

get_state_trace(caddr_t arg)
{
int i;
	ddi_copyout((caddr_t)state_trace,arg,sizeof(state_trace),0);
}
dump_field_timer(int count)
{
int i;
	for(i=0;i<count;i++)
	{
	    cmn_err(CE_WARN,"field_time[%d].load=%d field_time[%d].dma = %d\n",
		i,field_time[i].load,i,field_time[i].dma);
	}
}

#endif
char            Mark_pattern[8] = {5, 7, 11, 13, 17, 19, 23, 29};

subr_mark(tvtwo_softc *softc,int module,int line, int arg1,int  arg2)
{
	dvss_debug_buf_t *dp;
	int             i;
	if (Dbg_first_time) {
		for (i = 0; i < 8; i++)
			Mark_buf.marker[i] = Mark_pattern[i];
		Dbg_first_time = 0;
	}
	if (Dbg_index >= NDBGBUF)
		Dbg_index = 0;
	dp = &(Mark_buf.Dbg_buf[Dbg_index]);
	dp->time = XV_RREG(softc->regs,TmrCnt.l);	/* raw clock ticks */
	dp->module= module;
	dp->line = line;
	dp->value1 = arg1;
	dp->value2 = arg2;
	dp->dma_addr = XV_RREG(softc->regs, DMARB.l);
	dp->VcurAdd  = XV_RREG(softc->regs,VCurAdd.l);
	dp->WcurAdd  = XV_RREG(softc->regs,WCurAdd.l);
	Dbg_index++;

}
dump_marker(int mode)
{
	dvss_debug_buf_t *dp;
	int             i;
	char *header;

	if(Dbg_index==0)return;
	if(mode)
	{
            printf("dump_marker: marker count=%d\n",Dbg_index);
	for(i=0;i<Dbg_index;i++)
	{
	     dp = &(Mark_buf.Dbg_buf[i]);
	     switch(dp->module)
	     {
	     case CCUBE_R0:
		  header= "CCUBE_R0";
	          break;
	     case CCUBE_R1:
		  header = "CCUBE_R1";
		  break;
	     case CCUBE_R2:
		  header = "CCUBE_R2";
		  break;
	     case VCHAN_INTERRUPT:
		  header= "VCHAN_INTR";
	          break;
	     case PROCESS_EVENT:
		  header= "PROCESS_EVENT";
	          break;
	     case WCHAN_INTERRUPT:
		  header= "WCHAN_INTR";
	          break;
	     case CCUBE_INTERRUPT:
		  header= "process_C3";
		  break;
	     case CCUBE_W0:
		  header = "CCUBE_W0";
		  break;
	     case CCUBE_W1:
		  header = "CCUBE_W1";
		  break;
	     case CCUBE_W2:
		  header = "CCUBE_W2";
		  break;
	     case CCUBE_W3:
		  header = "CCUBE_W3";
		  break;
	     break;
	     }
	          printf("%s: line=%d time=%d dma_addr = 0x%x\n",header,
			dp->line,dp->time,dp->dma_addr);
	  printf("VcurAdd=%d WcurAdd=%d arg1=0x%x arg2=0x%x\n",
		  	dp->VcurAdd,dp->WcurAdd,dp->value1,dp->value2);
	}
	}
	Dbg_index=0;

}
static void
c3_error(tvtwo_softc *softc, char *message)
{
	cmn_err(CE_CONT, "C3_STATUS = 0x%x  XV_STATUS = 0x%x\n",
		C3_RREG(softc->regs, Flags),
		XV_RREG(softc->regs, IntStat.l));

	C3_WREG(softc->regs, Flags, C3_OFF);
	C3_WREG(softc->regs, Flags, C3_ON);
	C3_WREG(softc->regs, Flags, C3_OFF);

}
void
rtv_c3_load_dct(tvtwo_softc *softc)
{
	int i;

	C3_WREG(softc->regs,DCT[0],0x00005A82);
	C3_WREG(softc->regs,DCT[1],0x00007FFF);
	C3_WREG(softc->regs,DCT[2],0x000030FC);
	C3_WREG(softc->regs,DCT[3],0x00007642);
	C3_WREG(softc->regs,DCT[4],0x00005A82);
	C3_WREG(softc->regs,DCT[5],0x00007FFF);
	C3_WREG(softc->regs,DCT[6],0x000030FC);
	C3_WREG(softc->regs,DCT[7],0x00007642);
	C3_WREG(softc->regs,DCT[9],0);

}

void
rtv_c3_init(tvtwo_softc *softc)
{
	softc->imask= 0x8000;
	softc->bmask= _Int_Sbus;
	XV_WREG(softc->regs,IntMask.l,softc->imask);
	XV_WREG(softc->regs,BIntMask.l,softc->bmask);
	XV_WREG(softc->regs, C3Stall.l, 0x140);
	C3_WREG(softc->regs, S_reset, C3_ON);
	rtv_c3_load_dct(softc);
}

	



resetC3(tvtwo_softc *softc)
{
	C3_WREG(softc->regs,DRQ_Enable, 0);
	C3_WREG(softc->regs,NMRQ_Enable, 0);
	C3_WREG(softc->regs,S_reset, ~0);
	DELAY(50);
	XV_WREG(softc->regs,CCube.l, XVC3_RESET_TO_PIO);
}

#define DUMP_JPEG
#ifdef DUMP_JPEG
dump_jpeg(tvtwo_softc *softc,int mode,int bcount)
{
 	int i,dmp_start,dmp_end;
 	int *bptr;

	if(mode==RECORD)
	    bptr= (int *)softc->input_shared_data;
	else
	    bptr= (int *)softc->output_shared_data;
	dmp_end= bcount/4;
	dmp_start= (bcount/4)-128;

	for(i=dmp_start;i<dmp_end;i+=8)
	{
	       printf("jpeg[%d-%d] =0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x \n",i,i+8,
		 bptr[i],bptr[i+1],bptr[i+2],bptr[i+3],
		 bptr[i+4],bptr[i+5],bptr[i+6],bptr[i+7]);
	}
}
#endif
#ifdef SERVER_INTERRUPT_TIMER
decomp_timeout(tvtwo_softc *softc)
{
}
static void
decomp_timer_intr(tvtwo_softc *softc)
{

	softc->timer_active = 0;

	if (softc->timer_required == 0) {
		return;
	}

	softc->timer_count++;

	if (ci->timer_count >= 2) {
		decomp_timer_off(softc);
		decomp_timeout(softc);

		if (softc->timer_required == 0) {
			return;
		}
	}

	if (softc->timer_active == 0) {
		softc->timer_active = 
		    timeout(decomp_timer_intr, (caddr_t)softc, 200);
	}

	return;
}

static void
decomp_timer_start(tvtwo_softc *softc)
{
CCUBE_INFO *ci=softc->ci;

	softc->timer_required = 1;
	softc->timer_count = 0;

	if (softc->timer_active == 0) {
	    softc->timer_active = 
		timeout(decomp_timer_intr, (caddr_t)softc, 200);
	}

	return;
}
static void
decomp_timer_off(tvtwo_softc *softc)
{

	softc->timer_count = 0;
	untimeout(softc->timer_active);
	softc->timer_active=0;

	return;
}
#endif

C3InitDecomp(tvtwo_softc *softc)
{
	C3_WREG(softc->regs,S_reset, ~0);

	/* Load configuration registers */

#ifdef RGB422
	C3_WREG(softc->regs,Config, 0x100 + 0x38);
#else
	C3_WREG(softc->regs,Config, 0x100 + 0x28); 
#endif

	C3_WREG(softc->regs,DRQ_Enable,0);
	C3_WREG(softc->regs,NMRQ_Enable,0);

	C3_WREG(softc->regs,Init_1, 0x003e);
	C3_WREG(softc->regs,Init_2, 0x0037);
	C3_WREG(softc->regs,Init_3, 0x01ff);
	C3_WREG(softc->regs,Init_4, 0x0049);
	C3_WREG(softc->regs,Init_5, 0x0005);
	C3_WREG(softc->regs,Init_7, 0x0022);
	C3_WREG(softc->regs,QuantSync, 0x043e);
	C3_WREG(softc->regs,QuantYC, 0x2033);
	C3_WREG(softc->regs,QuantAB, 0x0000);
	C3_WREG(softc->regs,QuantSelect, 1);
	C3_WREG(softc->regs,VideoLatency, 0x017f);

	/* Load coder configuration registers */

	C3_WREG(softc->regs,CodecSeq, 0x00cc);
	C3_WREG(softc->regs,CodecCompH, 0x0088);
	C3_WREG(softc->regs,CodecCompL, 0x0044);
	C3_WREG(softc->regs,CoderAttr, 0x00004);
	C3_WREG(softc->regs,CodingIntH, 0x0000);
#ifdef RGB422
	C3_WREG(softc->regs,CodingIntL, 0x0002);
#else
	C3_WREG(softc->regs,CodingIntL, 0x001);
#endif
	C3_WREG(softc->regs,DecLength, 0x0008);
	C3_WREG(softc->regs,CodeOrder, 0x0001);

	/* Load RGB-YUV conversion matrix */

	C3_WREG(softc->regs,R2Y,0x00000400);
	C3_WREG(softc->regs,G2Y,0x00000FFE);
	C3_WREG(softc->regs,B2Y,0x000005C9);
	C3_WREG(softc->regs,R2U,0x00000400);
	C3_WREG(softc->regs,G2U,0x00000EA2);
	C3_WREG(softc->regs,B2U,0x00000D23);
	C3_WREG(softc->regs,R2V,0x00000400);
	C3_WREG(softc->regs,G2V,0x0000071B);
	C3_WREG(softc->regs,B2V,0x00000FFD);
}
