/*
** File: 
**
**  Xvddx_ROPS.h: Client accessable definitions for Xv video extension
**                DD level associated with RasterOps adaptors.
**
** Author: 
**
**   Andy Goodrich (Parallax)
**
** Revisions:
**
**   01 Jan 94 Goodrich
**     - Initial coding.
** $Log:   /plxhp/dave/pvcsrc/xv/include/archives/Xvddx_ROPS.h_v  $
 * 
 *    Rev 1.1   09 Sep 1996 10:38:02   dave
 * Initial revision
** Revision 1.1  1995/05/02 11:55:28  dist
** Initial revision
**
*/

#ifndef Xvddx_ROPS_h_INCLUDED
#define Xvddx_ROPS_h_INCLUDED

#include <sys/types.h>
#include "Xvddx.h"      /* Pick up generic DD level definitions. */

/*
 *  DEVICE-DEPENDENT ATTRIBUTES SUPPORTED:
 *
 *  Long attributes:
 *     1) "XV_ATTRIBUTES"" - return list of attribute atoms supported.
 *
 *  Integer attributes:
 *     1) "XV_BRIGHTNESS" - get or set brightness level (-1000..1000).
 *     2) "XV_CONTRAST" - get or set contrast level (-1000..1000).
 *     3) "XV_HUE" - get or set hue level (-1000..1000).
 *     4) "XV_ROP_FIELD_INVERT" - get or set inverting of fields. (0 or 1).
 *     5) "XV_ROP_HORIZONTAL_FLIP" - get or set hor. flipping of video (0 or 1).
 *     6) "XV_ROP_VERTICAL_FLIP" - get or set ver. flipping of video (0 or 1).
 *     7) "XV_SATURATION" - get or set saturation level (-1000..1000).
 *     8) "XV_STATUS" - get status of port (see Xvddx.h for status values).
 *
 *  Control operations:
 *     None
 */

enum { 
    XVROP_CTL_DIAGF_OFF = 0, 
    XVROP_CTL_DIAGF_ON, 
};   
 

#endif /* Xvddx_ROPS_h_INCLUDED */

