/*
 *  help_text.h: Help text for calibrate program.
 *
 */
#ifndef help_text_h_INCLUDED
#define help_text_h_INCLUDED

static char*	help_adjust[] = {
	"The alignment of the PowerVideo 700 image with that of the host",
	"frame buffer is accomplished using the arrow keys:",
	" ",
	"   Left Arrow -  each depression of the LEFT ARROW key will move the",
	"                 PowerVideo700 image left  5 pixels.",
	" ",
	"   Right Arrow - each depression of the RIGHT ARROW key will move the",
	"                 PowerVideo700 image right  5 pixels.",
	" ",
	"   Shift Left Arrow - each depression of the LEFT ARROW key with the",
	"                 SHIFT key pressed will move the PowerVideo700 image",
	"                 left 1/2 pixel.",
	" ",
	"   Shift Right Arrow - each depression of the RIGHT ARROW key with the",
	"                 SHIFT key pressed will move the PowerVideo700 image",
	"                 right 1/2 pixel.",
	" ",
	"   Up Arrow - each depression of the UP ARROW key will move the ",
	"                 PowerVideo700 image up 1 pixel.",
	" ",
	"   Down Arrow - each depression of the DOWN ARROW key will move the ",
	"                 PowerVideo700 image down 1 pixel.",
	" ",
	"   s Key - each depression will adjust the shift factor (width) down ",
	"           by two. ",
	" ",
	"   S Key - each depression will adjust the shift factor (width) up ",
	"           by two. "
};
#define n_help_adjust  (sizeof(help_adjust) / sizeof(char*))

static char*	help_calibrate[] = {
    "You will need to align the image of the Parallax overlay card with",
	"the image in your host frame buffer. This is accomplished with the",
	"Calibrate program. For each Parallax overlay card in your system",
	"you should perform the following steps: ",
	" ",
	"  1) Select the adaptor to be calibrated from the Adaptor menu item",
	"     found in the File menu.",
	" ",
	"  2) Choose the default timing for your host frame buffer by selecting",
	"     the Default menu item found in the File menu. ",
	" ",
	"  3) Adjust the non-zoomed video image using the keys as described in",
	"     the Adjust help item.",
	" ",
	"  4) Select zoom factor 2 from the Zoom menu and adjust the zoomed",
	"     video image using the keys as described in the Adjust help item.",
	" ",
	"  5) Reselect normal (no-zoom) from the Zoom menu and then save your",
	"     calibration settings by selecting the Save menu item from the",
	"     file menu.",
	" ",
	"Once you have calibrated all your adaptors and saved their settings",
	"you should be able to operate your Parallax overlay card(s) without",
	"having to run the Calibrate program again. If you move the card to a",
	"new system or change frame buffers you may need to run Calibrate again."
};
#define n_help_calibrate  (sizeof(help_calibrate) / sizeof(char*))


static char*	help_file[] = {
	"The file menu allows access to files containing alignment parameters",
	"and is used to quit the program. The menu items in the file menu are:",
	" ",
	"  About Calibrate - displays current version and date of Calibrate",
	" ",
	"  Adaptor - choose which adaptor to calibrate from a list of possible",
	"            adaptors",
	" ",
	"  Default - allows the user to load in alignment settings from a",
	"            file. Once loaded the settings will be used to align",
	"            the PowerVideo 700 with the host frame buffer.",
	" ",
	"  Load    - load the contents of the PowerVideo 700's nvram into this",
	"            program and use them to initialize the alignment.",
	" ",
	"  Save    - store the values from this program back into the nvram.",
	" ",
	"  Exit    - leave this program. Note that if no Save has been done",
	"            the settings will not be permanent."
};
#define n_help_file (sizeof(help_file) / sizeof(char*))

static char*	help_title[] = {
	"The title bar reflects the current settings of the calibration",
	"information. The values are: ",
	"    VFP - vertical front porch in scan lines",
	"    VBP - vertical back porch in scan lines",
	"    HFP - horizontal front porch to a 5-pixel boundary",
	"    HBP - horizontal back porch to a 5-pixel boundary",
	"    Delay - delay factor to adjust to single pixel boundary",
	"    Skip - skip factor to map interleave 5 to interleave 4"
};
#define n_help_title (sizeof(help_title) / sizeof(char*))


static char*	help_zoom[] = {
	"The zoom menu allows the user to choose what zoom factor is to be",
	"aligned with the Calibrate program. The menu items in the zoom menu are:",
	" ",
	"  Normal - configure the PowerVideo 700 card to use 1 to 1 zoom",
	" ",
	"  Zoom 2 - configure the PowerVideo 700 card to use 2 to 1 zoom"
};
#define n_help_zoom (sizeof(help_zoom) / sizeof(char*))

struct	_help_entry {
	char*	name;		/* -> name of help item. */
	char**	p_p_text;	/* -> text. */
	int		n_lines;	/* = number of lines of text. */
} help_items[] =
{
	{"Calibrate", help_calibrate, n_help_calibrate},
	{"Adjust",    help_adjust, n_help_adjust},
	{"File",      help_file,   n_help_file},
	{"Title",     help_title,  n_help_title},
	{"Zoom",      help_zoom,   n_help_zoom},
};
static int n_help_items = sizeof(help_items) / sizeof(struct _help_entry);

#endif  /* help_text_h_INCLUDED */
