/*
 *  xvtv.c:	Test program for Xv video extension access object.
 *
 *  CONVENTIONS:
 *    (1) Tab stops every 4 characters.
 *    (2) Routines are arranged in alphabetical order within file.
 *    (3) Variables are declared in alphabetical order within routines.
 *
 *  REVISION HISTORY:
 *
 *     26 May 93 - Andy Goodrich
 *       - Initial coding
 *
 * $Log:   /plxhp/dave/source/O_XV/archives/red.c_v  $
 * 
 *    Rev 1.0   12 Sep 1996 11:54:48   dave
 * init
 * Revision 1.2  95/08/31  12:58:49  12:58:49  dist ()
 * Andy Goodrich: Added O_XV_Video_On() because the startup semantics
 *                of an O_XV object have changed, video no longer 
 *                defaults on.
 * 
 * Revision 1.1  95/05/16  10:10:46  10:10:46  dist ()
 * Initial revision
 * 
 *  Copyright(c) 1993, Andrew C. Goodrich
 */
#include <sys/types.h>			/* Standard types for this C environment. */
#include <stdio.h>				/* Stream input/output declarations. */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <Xvlib.h>

#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>
 

/*----------------------------------------------------------------------------*
 |"main"
 |
 |  Entry point for system for this application.
 |
 *----------------------------------------------------------------------------*/
main( argc, argv )
	int		argc;		/* = # of command arguments parsed by shell. */
	char	*argv[];	/* = vector of pointers to command arguments parsed. */
{
	Display*	display;		/* Display accessing. */
	XColor      ecolor;
	XEvent		event;			/* Window event we are processing. */
	XGCValues   gc_attr;
	GC          gc;
	Window      main_win;
	Window      root;
    XColor      scolor;
	int			screen;
	XSetWindowAttributes  win_attr;
	
	if ( !(display = XOpenDisplay(0)) ) 
	{
		fprintf(stderr, "\nCould not open display\n");
		return 0;
	}

    root = XDefaultRootWindow(display);
	screen = XDefaultScreen(display);
	XAllocNamedColor(display, XDefaultColormap(display,screen), "red", 
		&scolor, &ecolor);

	win_attr.colormap = XDefaultColormap(display, screen);
	win_attr.background_pixel = scolor.pixel;
	win_attr.event_mask = ExposureMask;
	win_attr.backing_store = Always;
	win_attr.border_pixel = scolor.pixel;

	main_win = XCreateWindow(display, root, 0, 0, 1280, 1024, 0,
								 8, InputOutput, XDefaultVisual(display,screen),
								 CWColormap | CWBackPixel | CWEventMask |
								 CWBackingStore | CWBorderPixel,
								 &win_attr);
	XMapWindow(display, main_win);
	printf("\n      Waiting for window to become visible...\n");
	while (1)
	{
		XNextEvent(display, &event);
		if (event.type == Expose) break;
	}

	gc_attr.foreground = scolor.pixel;
	gc = XCreateGC(display, main_win, GCForeground, &gc_attr);
	XFillRectangle(display, main_win, gc, 0, 0, 1280, 1024);

	for(;;)
	{
		XNextEvent(display, &event);
	}
}
