/*
 *  help_text.h: Help text for calibrate program.
 *
 */
#ifndef help_text_h_INCLUDED
#define help_text_h_INCLUDED

static char*	help_file[] = {
	"The file menu allows access to files containing alignment parameters",
	"and is used to quit the program. The menu items in the file menu are:",
	" ",
	"  About XMTV - displays current version and date of XMTV",
	" ",
	"  Exit    - leave this program. "
};
#define n_help_file (sizeof(help_file) / sizeof(char*))

static char*	help_inputs[] = {
	"The input to use is selected with the Inputs menu, which is a four",
	"level cascade:",
	" ",
	"   Level One   - specifies what digitizer is to be used",
	" ",
	"   Level Two   - specifies which source format is to be used, Y/C",
	"                 or COMPOSITE",
	" ",
	"   Level Three - specifies which instance of input format is to be",
	"                 used, 1, 2, or 3.", 
	" ",
	"   Level Four  - Specifies the timing of the input, NTSC, PAL, or",
	"                 SECAM",
};
#define n_help_inputs  (sizeof(help_inputs) / sizeof(char*))

static char*	help_outputs[] = {
	"If your hardware provides output capability an Outputs menu will be",
	"displayed in the menu bar area. The Outputs menu is a two level",
	"cascade:",
	" ",
	"   Level One   - specifies what encoder is to be used",
	" ",
	"   Level Two   - Specifies the timing of the input, NTSC, PAL, or",
	"                 SECAM",
};
#define n_help_outputs  (sizeof(help_outputs) / sizeof(char*))

struct	_help_entry {
	char*	name;		/* -> name of help item. */
	char**	p_p_text;	/* -> text. */
	int		n_lines;	/* = number of lines of text. */
} help_items[] =
{
	{"File",    help_file,    n_help_file},
	{"Inputs",  help_inputs,  n_help_inputs},
	{"Outputs", help_outputs, n_help_outputs},
};
static int n_help_items = sizeof(help_items) / sizeof(struct _help_entry);

#endif  /* help_text_h_INCLUDED */
