/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log:   /plxhp/dave/source/driver/archives/c3dma.c_v  $
 * 
 *    Rev 1.5   12 Sep 1996 11:06:52   dave
 * final revs from rcs archives
 * Revision 1.4  96/01/08  13:35:46  13:35:46  dist (Software Distribution Account)
 * fixed up end of jpeg data
 * 
 * Revision 1.3  95/07/06  17:17:38  17:17:38  dist ()
 * Made changes to support faster clock speeds.
 * 
 * Revision 1.2  95/04/17  12:02:55  12:02:55  dist ()
 * Changes for multiple simultaneous cards in a system.
 * 
 * Revision 1.11  93/07/13  01:42:51  rocky
 * squash update for C3Stall
 * 
 * Revision 1.10  92/03/06  11:22:45  dave
 * made compatable with turbo, and took out eoi stuff
 * 
 * Revision 1.9  92/01/20  08:31:49  dave
 * fixed problem with read count
 * 
 * Revision 1.8  92/01/20  08:19:03  dave
 * fixed dma problem!!!
 * 
 * Revision 1.7  92/01/16  14:32:30  dave
 * fixed some minor stuff
 * 
 * Revision 1.6  91/12/18  14:28:29  dave
 * fixed potential timeout
 * 
 * Revision 1.5  91/10/24  15:04:36  mears
 * c3 stuff and dec stuff
 * 
 * Revision 1.4  91/09/10  13:53:58  dave
 * nochange
 * 
 * Revision 1.3  91/08/14  12:08:53  dave
 * lotsa changes
 * 
 * Revision 1.2  91/07/28  02:23:44  eric
 * new version from marty
 * 
 * Revision 1.1  91/07/11  18:00:43  eric
 * Initial revision
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: c3dma.c,v 1.11 93/07/13 01:42:51 rocky Exp $ Parallax Graphics Inc";
#endif

#include "xvideo.h"
#include "c3.h"
#include "stdio.h"
#include "machine/param.h"
#include "h/io.h"
#include "h/buf.h"			/* Needed by plxv_softc.h */
#include "c3dma.h"
#include "plxv.h"
#include "plxv_softc.h"

#define _Int_CCube	0x2

/* DEBUGGING MACROS:
 *    0x80  - routine tracing
 *    0x40  - interrupt service routine tracing
 *    0x01  - temporary tracing.
 */
/* #define PLXV_DIAG 0x80 */
#include "plxv_debug.h"

#define MAX_WAIT_TIME 0x100000
#if 0
#ifdef hpux
enum {
    DELAY1  = 1*10,
    DELAY5  = 5*10,
    DELAY10  = 10*10,
    DELAY50  = 50*10,
};
#else
#define DELAY5 5
#define DELAY10 10
#define DELAY50 50
#endif
#endif

/*#define doerr(p_xv, a1, a2)     printf("state %x: %s\n",a1,a2) */

#ifdef NOTDEF
static int start_addr, end_addr, xfr_count, gdmacnt;

static int timeout_flag=0;
#endif
int timeout_interval = 100;

extern k_addr;
#define QSIZE 10
int queue[QSIZE];
int qval[QSIZE];
int qtmr[QSIZE];
int qlen[QSIZE];
int qptr=0;
#define ADDQ(event,par) {int tmr,end_addr; \
		PV_RREG(p_xv,tmr, TmrCnt.l); \
		qtmr[qptr%QSIZE] = tmr; \
		PV_RREG(p_xv,end_addr, DMARB.l); \
		qlen[qptr%QSIZE] = end_addr; \
queue[qptr%QSIZE]=event; qval[qptr%QSIZE]=par; qptr++;}

purge_fifo(p_xv)
    XV_struct* p_xv;
{
/*
	PV_WREG(p_xv, C3Stall.l,0x100);
	DELAY(DELAY1);
*/
	PV_WREG(p_xv,CCube.l,XVC3_START_DMA_TO_HOST_1);
	PV_WREG(p_xv,CCube.l,XVC3_START_DMA_TO_HOST_2);
	DELAY(DELAY1);
	PV_WREG(p_xv,CCube.l, XVC3_PURGE_BIC_GO_PIO);
	DELAY(DELAY10);
	PV_WREG(p_xv,CCube.l, XVC3_RESET_TO_PIO);
	DELAY(DELAY5);
}

/*
 * The following is a read from the C3, which is a compression operation.
 */

static void c3_fetch_flags( p_xv, p_flags, p_timer)
	XV_struct*	  p_xv;
	unsigned int* p_flags;
	unsigned int* p_timer;
{
	    C3_RREG(p_xv, *p_flags, Flags);
		DELAY(5);
		PV_RREG(p_xv, *p_timer, TmrCnt.l);
}

/* #define TIMEVINACTIVE /* */

#if defined(mips) || defined(hpux)
c3_start_read(dmabuf, dmacnt, unit)
#else
c3_start_read(dmabuf, dmacnt)
#endif
unsigned int 	*dmabuf;	/* DMA buffer address			*/
unsigned int	dmacnt;		/* DMA max transfer count (bytes)	*/
				/* ...MUST BE A MULTIPLE OF 4		*/
{
	unsigned int    c3_status;
	int 			i;
	XV_struct*		p_xv;
	SOFTC*	    	softc;
	unsigned int	timer_before; /* Timer value before start of poll loop. */
	unsigned int	timer_after;  /* Timer value before start of poll loop. */
	unsigned int    xv_status;


	/* Set initial state */

	DEBUGF(0x80, ("c3_start_read: dmacnt=%d\n",dmacnt));

	softc = unit_to_softc(unit);
	p_xv = softc->xv;

	PV_WREG(p_xv,C3Stall.l,0x100);

	ADDQ(2,dmacnt);
#if 0
	PV_WREG(p_xv,DMASA1.l, (unsigned) (dmabuf)>>2);	
	PV_WREG(p_xv,DMASA2.l, (unsigned) (dmabuf)>>2);
	PV_WREG(p_xv,DMAEA1.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
	PV_WREG(p_xv,DMAEA2.l, ((unsigned) dmabuf + dmacnt - 4)>>2);

	purge_fifo(p_xv);
#endif

	PV_WREG(p_xv,C3Stall.b.cond,STALL_H);

	softc->start_addr = (int) dmabuf;
	softc->gdmacnt = dmacnt;
	
	/* load the DMA buffers the same */

	PV_WREG(p_xv,DMASA1.l, (unsigned) (dmabuf)>>2);	
	PV_WREG(p_xv,DMASA2.l, (unsigned) (dmabuf)>>2);
	PV_WREG(p_xv,DMAEA1.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
	PV_WREG(p_xv,DMAEA2.l, ((unsigned) dmabuf + dmacnt - 4)>>2);

	/* start the compressor */

try_again:

	C3_WREG(p_xv,HV_Enable, ~0);
	C3_WREG(p_xv,HV_Enable, 0);
	C3_WREG(p_xv,HV_Enable, ~0);
	C3_WREG(p_xv,Start, ~0);

#ifdef TIMEVINACTIVE
    PV_WREG(p_xv, TmrSpd.l, 0x171);	/* init the timer */

	do
	{
		PV_RREG(p_xv, timer_before, TmrCnt.l);
	} while(timer_before > 10);	/* wait for timer to start */
#endif

	/* wait for the video to go active and enable interrupts */

	do
	{
		c3_fetch_flags(p_xv, &c3_status, &timer_after);
	} while (!(c3_status & _Int_VInactive));

	do
	{
		c3_fetch_flags(p_xv, &c3_status, &timer_after);
	} while (c3_status & _Int_VInactive);

#ifdef TIMEVINACTIVE
	if((timer_after - timer_before) > 100)
	{
		printf("c3_start_read: VInactive went low in %d ticks (a=%d b=%d",
				timer_after - timer_before,
				timer_after , timer_before);

			printf("               C3 Flags are (0x%x)\n", c3_status);
	}
#endif

	PV_WREG(p_xv,C3Stall.b.cond,STALL_H_O_FE);

	C3_WREG(p_xv,NMRQ_Enable, _Int_VInactive);

	/* Start the DMA going */

	C3_WREG(p_xv,DRQ_Enable, _Int_Codec_RegBusy | _Int_FIFO_QFull);
	PV_WREG(p_xv,CCube.l,XVC3_START_DMA_TO_HOST_1);
	PV_WREG(p_xv,CCube.l,XVC3_START_DMA_TO_HOST_2);

#if 0
	PV_RSDW(p_xv, i, IntMask.l);
	PV_WREG(p_xv,IntMask.l, i | _Int_CCube | 0x8000);
#else
	PV_WREG(p_xv,IntMask.l, _Int_CCube | 0x8000);
#endif
	PV_WREG(p_xv,BIntMask.l, 1);

	PV_RREG(p_xv, i, IntStatC.l);
	PV_RREG(p_xv, i, BIntStatC.l);
		
#if defined(mips) || defined(hpux)
	set_timeout(softc, unit);
#else
	set_timeout(softc);
#endif
	return(STATER1);
}

/*
 * The following is a write of an image to the C3.  It assumes that the 
 * specified buffer contains the complete image and that a "~0" terminates
 * the buffer.  A write to the C3 is a decompression operation.   The write
 * returns once all data has been transferred to the C3; however, the video
 * pipeline may still be busy.
 */
#if defined(mips) || defined(hpux)
c3_start_write(dmabuf, dmacnt, unit)
#else
c3_start_write(dmabuf, dmacnt)
#endif
unsigned int 	*dmabuf;	/* DMA buffer address			*/
unsigned int	dmacnt;		/* DMA max transfer count (bytes)	*/
				/* ...MUST BE A MULTIPLE OF 4		*/
{
	unsigned int c3_status,xv_status;
	int 		pri;
	int i;
    XV_struct*	p_xv;
	SOFTC*		softc;

	/* Set initial state */

	softc = unit_to_softc(unit);
	p_xv = softc->xv;

    DEBUGF(0x80, ("c3_start_write: dmacnt=%d\n",dmacnt));
	PV_WREG(p_xv,C3Stall.l,0x140);

        PV_WREG(p_xv,CCube.l,XVC3_RESET_TO_PIO);
        PV_WREG(p_xv,C3Stall.b.cond,STALL_ALWAYS);

	softc->start_addr = (int) dmabuf;
	softc->gdmacnt = dmacnt;

	/* Load the DMA buffer address */

	ADDQ(3,dmacnt);
	PV_WREG(p_xv,DMASA1.l, (unsigned) (dmabuf)>>2);	
	PV_WREG(p_xv,DMASA2.l, (unsigned) (dmabuf)>>2);
	PV_WREG(p_xv,DMAEA1.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
	PV_WREG(p_xv,DMAEA2.l, ((unsigned) dmabuf + dmacnt - 4)>>2);

	/*
	 * DRQ until FIFO is 3/4 full, then interrupt.  DRQs are
	 * disabled and an interrupt is generated if a marker code is
	 * found. 
	 */

	C3_WREG(p_xv,NMRQ_Enable, _Int_FIFO_3QFull /* | _Int_MarkerCode */);
	C3_WREG(p_xv,DRQ_Enable, _Int_Codec_RegBusy | _Int_FIFO_Not3QFull);

	/* 
	 * Enable interrupts in the XVideo hardware 
	 */
#if 0
	PV_RSDW(p_xv, i, IntMask.l);
	PV_WREG(p_xv,IntMask.l, i | _Int_CCube | 0x8000);
#else
	PV_WREG(p_xv,IntMask.l, _Int_CCube | 0x8000);
#endif
	PV_WREG(p_xv,BIntMask.l, 1);
	PV_RREG(p_xv, i, IntStatC.l);
	PV_RREG(p_xv, i, BIntStatC.l);

        PV_WREG(p_xv,CCube.l,XVC3_START_DMA_FROM_HOST_1);
        PV_WREG(p_xv,CCube.l,XVC3_START_DMA_FROM_HOST_2);

#if defined(mips) || defined(hpux)
	set_timeout(softc, unit);
#else
	set_timeout(softc);
#endif

	return(STATEW1);
}

#if defined(mips) || defined(hpux)
xvbuf_int_svc(c3_state,c3_rcount, unit)
#else
xvbuf_int_svc(c3_state,c3_rcount)
#endif
unsigned int c3_state;
unsigned int *c3_rcount;
{
	unsigned int c3_status,xv_status;
	int i;
	int          tdif;
    XV_struct*	 p_xv;
	SOFTC*		 softc;

	if (c3_state == STATE_ERR) return;

	softc = unit_to_softc(unit);
	p_xv = softc->xv;

#ifdef NOTDEF /* this is done at beginning of int serve */


	PV_RREG(p_xv,softc->end_addr, DMARB.l);
	softc->end_addr += 4;

	if (c3_state & STATEW) {
		PV_WREG(p_xv,CCube.l, XVC3_PAUSE_DMA_FROM_HOST);
		DELAY(DELAY10);
		PV_WREG(p_xv,CCube.l, XVC3_WRITE_GO_PIO);
	} else {
		PV_WREG(p_xv,CCube.l, XVC3_PAUSE_DMA_TO_HOST);
		DELAY(DELAY50);
		PV_WREG(p_xv,CCube.l, XVC3_PURGE_BIC_GO_PIO);
	}
	DELAY(DELAY10);
#endif

	C3_RREG(p_xv,c3_status, Flags);
	C3_WREG(p_xv,NMRQ_Enable, 0);
	C3_WREG(p_xv,DRQ_Enable, 0);

	DEBUGF(0x80, ("xvbuf_int_svc: c3_state=%d\n",c3_state));
	ADDQ(0,c3_state);
	switch (c3_state) {
	case STATEW1:	
		/*
		 * all the data has been read from the bus...now start the
		 * decompressor and wait for the video pipe to go inactive.
		 */
		C3_WREG(p_xv,HV_Enable, ~0);
		C3_WREG(p_xv,HV_Enable, 0);
		C3_WREG(p_xv,HV_Enable, ~0);
		C3_WREG(p_xv,Start, ~0);

		PV_WREG(p_xv,C3Stall.b.cond, STALL_NEVER);
		do
		{
		    C3_RREG(p_xv,c3_status, Flags);
		} while (!(c3_status & _Int_VInactive));

		do
		{
		    C3_RREG(p_xv,c3_status, Flags);
		} while ((c3_status & _Int_VInactive));

		C3_WREG(p_xv,NMRQ_Enable, _Int_VInactive);
		PV_WREG(p_xv,C3Stall.b.cond, STALL_FE);

		c3_state = STATEW3;
		break;

	case STATEW2:
	    {
		unsigned int timers, timernow;
		/*
		 * all the data has been read from the bus... now wait for
		 * the video pipe to go inactive.
		 */
#if defined(mips) || defined(hpux)
		c3_clear_timeout(softc, unit);
#else
		c3_clear_timeout(softc);
#endif

		PV_WREG(p_xv,C3Stall.b.cond, STALL_NEVER);
		PV_RREG(p_xv,timers, TmrCnt.l);
		do
		{
			C3_RREG(p_xv,c3_status, Flags);
			PV_RREG(p_xv,timernow, TmrCnt.l);
			tdif = timernow - timers;
			if (tdif<0) tdif = 100000;
		} while ((tdif < 60) &&
			     (!(c3_status & _Int_VInactive)));
		 /* the theory here is we want to only wait for 60 ticks, in
			case the buffer terminated before the completion of the
			frame.  since TmrCnt is an unsigned number that could
			roll over while this do loop is in process, we have to
			check for that condition */

		C3_WREG(p_xv,HV_Enable, ~0);
		C3_WREG(p_xv,HV_Enable, 0);
		C3_WREG(p_xv,HV_Enable, ~0);
		C3_WREG(p_xv,Start, 0);
		C3_WREG(p_xv,S_reset, ~0); /* #### */
		softc->xfr_count = softc->end_addr - softc->start_addr;
		*c3_rcount = softc->xfr_count;
		c3_state = STATE0;
		break;
	    }
	default:
		/* 
		 * the buffer must have been overrun...flag the error
		 */
		doerr(p_xv, c3_state,"Buffer overrun on read");
		c3_state = STATE_ERR;
		break;
	}

	if (c3_state == STATE_ERR) {
		C3_WREG(p_xv,DRQ_Enable, 0);
		C3_WREG(p_xv,NMRQ_Enable, 0);
		PV_WREG(p_xv,CCube.l, XVC3_RESET_TO_PIO);

#if defined(mips) || defined(hpux)
		c3_clear_timeout(softc, unit);
#else
		c3_clear_timeout(softc);
#endif

#ifdef NOTDEF /* this is done in library, not here */
		/*
		 * Clear out buffer, leave EOI marker code.
		 */
		* (int * ) softc->start_addr = 0xffd90000;
		*c3_rcount = 4;
#endif
		*c3_rcount = 0;
	} else {
#if 0
		PV_RSDW(p_xv, i, IntMask.l);
		PV_WREG(p_xv,IntMask.l, i | _Int_CCube | 0x8000); 
#else
		PV_WREG(p_xv,IntMask.l, _Int_CCube | 0x8000); 
#endif
		if (c3_state & STATEW) {
			PV_WREG(p_xv,BIntMask.l, 1);
			PV_WREG(p_xv,CCube.l, XVC3_CONT_DMA_FROM_HOST_1);
			PV_WREG(p_xv,CCube.l, XVC3_CONT_DMA_FROM_HOST_2);
		}
	}
	return(c3_state);
}


#if defined(mips) || defined(hpux)
c3_int_svc(c3_state,c3_rcount, unit)
#else
c3_int_svc(c3_state,c3_rcount)
#endif
unsigned int c3_state;
unsigned int *c3_rcount;
{
	unsigned int c3_status,xv_status;
	unsigned int c3_mask,xv_mask;
	unsigned int xv_status2;
	unsigned int eadd;
	unsigned int i,rval,rval2;
	XV_struct*	 p_xv;
	SOFTC*		 softc;


	if (c3_state == STATE_ERR) return;

	softc = unit_to_softc(unit);
	p_xv = softc->xv;
        PV_WREG(p_xv,C3Stall.b.cond,STALL_ALWAYS);

	/*
	 * Temporarily stop DMA and get XV and C3 state, clearing interrupt
	 * condition.
	 */

#ifdef NOTDEF /* done at begging of int serve */
	if (c3_state & STATEW) {
		PV_WREG(p_xv,CCube.l, XVC3_PAUSE_DMA_FROM_HOST);
		DELAY(DELAY10);
		PV_WREG(p_xv,CCube.l, XVC3_WRITE_GO_PIO);
	} else {
		PV_WREG(p_xv,CCube.l, XVC3_PAUSE_DMA_TO_HOST);
		DELAY(DELAY50);
		PV_WREG(p_xv,CCube.l, XVC3_PURGE_BIC_GO_PIO);
	}
	DELAY(DELAY10);
#endif

	C3_RREG(p_xv,c3_status, Flags);
	C3_WREG(p_xv,NMRQ_Enable, 0);
	C3_WREG(p_xv,DRQ_Enable, 0);

#if defined(mips) || defined(hpux)
	c3_clear_timeout(softc, unit);
	set_timeout(softc, unit);
#else
	c3_clear_timeout(softc);
	set_timeout(softc);
#endif
    DEBUGF(0x40, ("c3_svc_int: c3_state= %d\n",c3_state));

	/*
	 * Process the interrupt depending on which state we're in.
	 */
	ADDQ(1,c3_state);
	switch (c3_state) {
	case STATEW1:	
		if (c3_status & _Int_FIFO_3QFull) {
			/*
			 * The FIFO is now 3/4 full.  Reset the DRQ and IRQ
			 * conditions: DRQ while FIFO is not 3/4 full and 
			 * interrupt when end of buffer has been reached.
			 */

			C3_WREG(p_xv,NMRQ_Enable, _Int_FIFO_NotQFull);
			C3_WREG(p_xv,DRQ_Enable, _Int_Codec_RegBusy 
				| _Int_FIFO_Not3QFull);
			/*
			 * Start the decompressor.
			 */
			C3_WREG(p_xv,HV_Enable, ~0);
			C3_WREG(p_xv,HV_Enable, 0);
			C3_WREG(p_xv,HV_Enable, ~0);
			C3_WREG(p_xv,Start, ~0);

			PV_WREG(p_xv,C3Stall.b.cond, STALL_NH);

			c3_state = STATEW2;
		} else {
			doerr(p_xv, c3_state, "Bad Interrupt");
			*c3_rcount = 0;
			c3_state = STATE_ERR;
		}
		break;

	case STATEW2:
		/*
		* End of buffer has been reached. or the fifo is less than 1
		* quarter full.
		*/
		if(c3_status & _Int_FIFO_NotQFull)
		{
		 printf("int not q full\n");
		 /*
		 * DRQ until FIFO is 3/4 full, then interrupt.  DRQs are
		 * disabled and an interrupt is generated if a marker code is
		 * found.
		 */
		 C3_WREG(p_xv,NMRQ_Enable, _Int_FIFO_3QFull /* | _Int_MarkerCode*/);
		 C3_WREG(p_xv,DRQ_Enable, _Int_Codec_RegBusy | _Int_FIFO_Not3QFull);


		 c3_state = STATEW1;
		}
		else
		{
		 /*
		  * If we get here instead
		  * of processing this state in xvbuf_int_svc(), its an error. 
		  */
		 doerr(p_xv, c3_state, "Bad Interrupt");
		 *c3_rcount = 0;
		 c3_state = STATE_ERR;
		}
		break;

	case STATEW3:
		/*
		 * The video pipe has gone inactive.  We need to tell the
		 * decompressor to stop so that it doesn't expect more
		 * frames.
		 */
		C3_WREG(p_xv,HV_Enable, ~0);
		C3_WREG(p_xv,HV_Enable, 0);
		C3_WREG(p_xv,HV_Enable, ~0);
		C3_WREG(p_xv,Start, 0);
		C3_WREG(p_xv,S_reset, ~0);  /* #### */
		softc->xfr_count = softc->end_addr - softc->start_addr;
		*c3_rcount = softc->xfr_count;
		c3_state = STATE0;
		break;

	case STATER1:
		/* 
		 * The video pipeline is now stopped.  Now tell the C3
		 * to stop and drain the FIFO.
		 */
		if (c3_status & _Int_VInactive) {
			PV_RREG(p_xv,softc->state_r1_count, DMARB.l);
			softc->state_r1_count = (softc->state_r1_count - 
						softc->start_addr) + 4;
			C3_WREG(p_xv,HV_Enable, ~0);
			C3_WREG(p_xv,HV_Enable, 0);
			C3_WREG(p_xv,HV_Enable, ~0);
			C3_WREG(p_xv,Start, 0);
#if 0
			C3_WREG(p_xv,DRQ_Enable, _Int_Codec_RegBusy 
				| _Int_FIFO_NotEmpty);
#else
			C3_WREG(p_xv,DRQ_Enable, _Int_Codec_RegBusy 
				| _Int_FIFO_NotEmpty | _Int_FIFO_Empty);
#endif
			C3_WREG(p_xv,NMRQ_Enable, _Int_FIFO_Empty);

			c3_state = STATER2;
		} else {
			doerr(p_xv, c3_state, "Bad Interrupt");
			*c3_rcount = 0;
			c3_state = STATE_ERR;
		}
		break;

	case STATER2:
		/*
		 * The FIFO is now empty.  Pump the Codec one more time
		 * to get the last word.  Gather stats and exit.
		if (c3_status & _Int_FIFO_Late) {
			doerr(p_xv, c3_state, "Overrun Error");
			*c3_rcount = 0;
			c3_state = STATE_ERR;
		}
	 	 */
		if (c3_status & _Int_FIFO_Empty) {
			/*
			 * We're done 
			 */
			get_last_word_r(softc);
#if 0
			softc->xfr_count = (softc->end_addr - softc->start_addr)
					   + 8;
			PV_WREG(p_xv,CCube.l,XVC3_RESET_TO_PIO);
			DELAY(DELAY10);
			C3_WREG(p_xv,DRQ_Enable,0);
			PV_RREG(p_xv, softc->end_addr, DMARB.l);
			softc->xfr_count = softc->end_addr - softc->start_addr;
#else
			/* return count at R1 int */
			softc->xfr_count = softc->state_r1_count;
#endif
			*c3_rcount = softc->xfr_count;
			c3_state = STATE0; 
		} else {
			doerr(p_xv, c3_state, "Bad Interrupt");
			*c3_rcount = 0;
			c3_state = STATE_ERR;
		}
		break;

	default:
		doerr(p_xv, c3_state,"Bad c3int state");
		*c3_rcount = 0;
		c3_state = STATE_ERR;
		break;
	}

	/* 
 	 * IF c3_state = STATE0, we're done, so clean up and get out.  
	 * Otherwise, enable interrupts and restart DMA.
	 */
	if ((c3_state == STATE0) || (c3_state == STATE_ERR)) {
		unsigned int ovr;

		C3_WREG(p_xv,DRQ_Enable, 0);
		C3_WREG(p_xv,NMRQ_Enable, 0);

		PV_WREG(p_xv,CCube.l, XVC3_RESET_TO_PIO);
#if defined(mips) || defined(hpux)
		c3_clear_timeout(softc, unit);
#else
		c3_clear_timeout(softc);
#endif
		if (c3_state==STATE_ERR) {
			*c3_rcount = 0;
		}	
	} else {
#if 0
		PV_RSDW(p_xv, i, IntMask.l);
		PV_WREG(p_xv,IntMask.l, i | _Int_CCube | 0x8000); 
#else
		PV_WREG(p_xv,IntMask.l, _Int_CCube | 0x8000); 
#endif
		if (c3_state != STATEW3) {
			if (c3_state & STATEW) {
				PV_WREG(p_xv,BIntMask.l, 1);
				PV_WREG(p_xv,CCube.l, XVC3_CONT_DMA_FROM_HOST_1);
				PV_WREG(p_xv,CCube.l, XVC3_CONT_DMA_FROM_HOST_2);
			} else { 
				PV_WREG(p_xv,BIntMask.l, 1);
				PV_WREG(p_xv,CCube.l, XVC3_CONT_DMA_TO_HOST_1);
				PV_WREG(p_xv,CCube.l, XVC3_CONT_DMA_TO_HOST_2);
			}
		}
	}
	return(c3_state);
}

doerr(p_xv, state, s)
    XV_struct*	 p_xv;
    unsigned int state;
    char* 		 s;
{

	unsigned int c3_status, xv_status;
	unsigned int xv_status2;
	unsigned int c3_status2;

	PV_RREG(p_xv,xv_status, IntStat.l);
	PV_RREG(p_xv,xv_status2, IntStatC.l);
	C3_RREG(p_xv,c3_status, Flags);
	printf("%s in state %x:  ",s,state);
	printf("C3_STATUS = %x  XV_STATUS = %x\n",c3_status, xv_status);

	C3_WREG(p_xv,Flags, 0);
	C3_WREG(p_xv,Flags, ~0);
	C3_WREG(p_xv,Flags, 0);

}


do_marker()
{
	return(FALSE);
}


get_last_word_r(softc)
	SOFTC*	softc;
{
    XV_struct*	p_xv;

	p_xv = softc->xv;

        C3_WREG(p_xv,DRQ_Enable, _Int_Codec_RegBusy
                | _Int_FIFO_NotEmpty | _Int_FIFO_Empty);


	PV_WREG(p_xv,CCube.l, XVC3_CONT_DMA_TO_HOST_1);
	PV_WREG(p_xv,CCube.l, XVC3_CONT_DMA_TO_HOST_2);

	DELAY(DELAY5);

	PV_WREG(p_xv,CCube.l,XVC3_PURGE_C3_CONT_DMA);
	PV_WREG(p_xv,CCube.l,XVC3_PAUSE_DMA_TO_HOST);

	DELAY(DELAY10);
	PV_WREG(p_xv,CCube.l,XVC3_PURGE_BIC_GO_PIO);
	PV_WREG(p_xv,CCube.l,XVC3_PURGE_BIC_GO_PIO);
	DELAY(DELAY10);
	PV_WREG(p_xv,CCube.l,XVC3_RESET_TO_PIO);
	DELAY(DELAY10);

	C3_WREG(p_xv,DRQ_Enable,0);

	PV_RREG(p_xv, softc->end_addr, DMARB.l);
	softc->end_addr += 4;
}


extern c3intr();

#if defined(mips) || defined(hpux)
do_timeout(unit)
#else
do_timeout()
#endif
{
	XV_struct*	p_xv;
	SOFTC*	    softc;

	softc = unit_to_softc(unit);
	p_xv = softc->xv;

	if ( timeout_interval == 500 )
        {
#if defined(mips) || defined(hpux)
	    printf("do_timeout: unit = %d\n", unit);
#else
	    printf("do_timeout\n");
#endif
        }
	softc->timeout_flag = 1;

	PV_WREG(p_xv,CCube.l,XVC3_PURGE_BIC_GO_PIO);
	DELAY(DELAY10);
	PV_WREG(p_xv,CCube.l, XVC3_RESET_TO_PIO);
	DELAY(DELAY10);
	C3_WREG(p_xv,DRQ_Enable, 0);
	C3_WREG(p_xv,NMRQ_Enable, 0);

#if defined(mips) || defined(hpux)
	service_timeout(unit);
#else
	service_timeout();
#endif
}

#if defined(mips) || defined(hpux)
set_timeout(softc, unit)
#else
set_timeout(softc)
#endif
	SOFTC*	softc;
{
	softc->timeout_flag = 0;
#if defined(mips) || defined(hpux)
	timeout(do_timeout,unit, timeout_interval, NULL);
#else
	timeout(do_timeout,0, timeout_interval);
#endif
}

#if defined(mips) || defined(hpux)
c3_clear_timeout(softc, unit)
int unit;
#else
c3_clear_timeout(softc)
#endif
	SOFTC*	softc;
{
	softc->timeout_flag = 0;
#if defined(mips) || defined(hpux)
        untimeout(do_timeout,unit);
#else
	untimeout(do_timeout,0);
#endif
}

print_q()
{
	int i;

	for (i=qptr; i<(qptr+QSIZE); i++) {
		printf("%d %d %d %d\n",queue[i%QSIZE],qval[i%QSIZE],qtmr[i%QSIZE],qlen[i%QSIZE]);
	}
	printf("\n");
}
