#ifndef plxv_softc_h_INCLUDED
#define plxv_softc_h_INCLUDED


typedef struct
{
    unsigned long start_address;
    unsigned long counters;
    unsigned long control;
} dma_ctl;


/*
 *  Device driver SOFTware Control block definition:
 */
typedef struct plxv_softc {
    int             attached;           /* we were attached              */
	int             BIntStat;           /* last value read from BIntStat reg. */
    int             bit1size;           /* total size of 1 bit frame buffer */
    int             bit24size;          /* total size of 24 bit frame buffer */
    int             bit8size;           /* total size of 8 bit frame buffer */
    int             blank;              /* blank or not */
    int             c3_present;         /* = 1 if c3_present. */
    struct buf      dmabuf;             /* buffer struct for dma */
    dma_ctl         *dmactl;            /* pointer to dma control regs */
    unsigned int    dmactlbits;         /* bits for above */
    int             dmastate;           /* dma / interupt state */
	int				end_addr;			/* Ending address of dma operation. */
	int				gdmacnt;			/* #### */
    int             h;                  /* frame buffer height.  */
    int             int_pri;            /* interrupt priority             */
	int             IntStat;		    /* last value read from IntStat reg. */
    struct isc_table_type *isc;         /* boards isc */
    unsigned int    ladd;				/* last buffer address. */
    int             *memaddr;           /* board virtual address */
    struct proc     *owner;             /* owner of the frame buffer */
	int				pll_good_count;		/* pll : # of times aligned. */
	int				pll_minor_adjust;	/* pll : adjustment #, adjust on odds.*/
    u_long          plxv_physical;      /* board physical base address */
    int             *regaddr;           /* register block virtual address */
    int             shmid;              /* shared memory id of address space */
	int 			start_addr;			/* Starting address of dma operation. */
	int 			timeout_flag;		/* DMA timeout flag. */
    int             w;					/* frame buffer width. */
	int				xfr_count;			/* Transfer count remaining for dma. */
    XV_struct       *xv;                /* structure returned by hlib */
    unsigned int	state_r1_count;		/* count at time of stater1 int */
    int             vfield;             /* field for field flash */
    int             startfield;         /* starting field before jpeg */
    int             wffield;            /* wait for field compress */
    int		    visleep;		/* wffield is sleeping */
    int		    viwake;		/* for sleep */
    int		    intlvl;
    int		    unit;		/* unit for this softc */
} SOFTC;

#endif  /* plxv_softc_h_INCLUDED */
