/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log:   /plxhp/dave/pvcsrc/hwlib/archives/drawlib.c_v  $
 * 
 *    Rev 1.1   09 Sep 1996 10:11:04   dave
 * Initial revision
 * Revision 1.1  1996/07/22 20:11:01  dist
 * Initial revision
 *
 * Revision 1.4  95/07/19  09:33:06  09:33:06  dist ()
 * fixed by 5 interleave blit problem
 * 
 * Revision 1.3  95/05/25  17:11:15  17:11:15  dist ()
 * Andy Goodrich - Combined HP/AIX version for HP 9.1 code freeze.
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: drawlib.c,v 1.1 1996/07/22 20:11:01 dist Exp $ Parallax Graphics Inc";
#endif

#if 0
#include "xvideo.h"
#include "plxv.h"
#else
#include "hw_context.h"
#endif


#define NARROW_BOX_BUG	/* certain boxes narrower than the interleave factor are incorrectly drawn */

static int plxv_accel_color,rop_num,stencil_mask;
static int plxv_wmask_val;

extern int is_28_now;

#ifdef mips
#define WBFLUSH wbflush();
#else
#define WBFLUSH ;
#endif

#ifdef AIX
#include <sys/inline.h>
#define CacheFlush {eieio();}
#else
#define CacheFlush
#endif

#ifndef DRIVER /* ----------------- */
#ifdef SHARED_MEMORY
extern int ShmPointer;
#define PLXV_INHIBIT \
      { \
        if(!ShmPointer) PlxvShmAttach(); \
        while(*((int *) ShmPointer)) usleep(1); \
      }
#else          
#define PLXV_INHIBIT ;
#endif

#else          
#define PLXV_INHIBIT ;
#endif         /* ----------------- */

/* ^ ---------------------------------------------------------------------
 */

plxv_28_now(p_me, sel)
XV_struct* p_me;
int sel;
{
    PLXV_INHIBIT;
    is_28_now = sel;
    PV_WREG(p_me,RopCtl.b.em28,sel);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 */

plxv_init_draw(p_me)
XV_struct* p_me;
{
    PLXV_INHIBIT;
    PV_WREG(p_me,KeyColCtl.l,0);     /* disable video blue hardware here for now */
    plxv_map_ctl(p_me, 0,0x1f,0);     /* misc things to do go here for now */
    plxv_vector_window(p_me, 0,0);
}

/* ^ ---------------------------------------------------------------------
 * 24 bit stuff
 */

plxv_mode_24(p_me)
XV_struct* p_me;
{
    PLXV_INHIBIT;
    plxv_wf_done(p_me);
    plxv_tag(p_me, PLXV_TAG_PIXEL_ATTR,PLXV_TAG_TRUE_COLOR|1);	
    plxv_wmask(p_me, PLXV_WMASK_PIXEL_ALL);
    plxv_stencil(p_me, 0,0);		/* draw all pixels */
    plxv_rop(p_me, PLXV_ROP_COPY);
    plxv_transp_off(p_me);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 */

plxv_color_24(p_me, val)
    XV_struct* p_me;
{
    int i;
    plxv_wf_done(p_me);
    if (is_28_now)  {
	i = (val & 0xf000000) << 4;
	val = (val & 0xfffffff) | i;
    }
    plxv_accel_color = val;
    PV_WREG(p_me,SolidCol.l, val);
}

/* ^ ---------------------------------------------------------------------
 * 8 bit stuff
 */

plxv_mode_8(p_me)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    plxv_tag(p_me, PLXV_TAG_PIXEL_ATTR,PLXV_TAG_PSEUDO_COLOR|1);	
    plxv_wmask(p_me, PLXV_WMASK_PIXEL_ALL);
    plxv_stencil(p_me, 0,0);		/* draw all pixels */
    plxv_rop(p_me, PLXV_ROP_COPY);
    plxv_transp_off(p_me);
    plxv_map_ctl(p_me, 0,0x1f,0);
    plxv_read8(p_me, 0);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * set color value for accel operations with an 8 bit value 
 */

plxv_color_8(p_me, i)
XV_struct* p_me;
{
    int k,j = 0;

    plxv_wf_done(p_me);
    if ( is_28_now) {
	j = (i & 0xf) | ((i & 0xf) << 4) ;
	j = (j<<24);
    } 
    k = (i) | (i<<8) | (i<<16) | j;
    plxv_accel_color =k;
    PV_WREG(p_me,SolidCol.l, k);
}

/* ^ ---------------------------------------------------------------------
 * select which byte to read from when accessing 8 bit map 
 * select=0 means readback red, 1=green, 2= blue and 3=tag  
 */

plxv_read8(p_me, select)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
#if GA_REV==GAREV_1
    PV_WREG(p_me,TagCtl.b.m8rb, select);
#else
    PV_WREG(p_me,MMode.b.m8rb,(select & 0x3));
#endif
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * one bit stuff   
 */

plxv_mode_1(p_me)
    XV_struct* p_me;
{
    plxv_tag(p_me, 3,1);
    plxv_rop(p_me, 5);
    plxv_stencil(p_me, 0,0);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * set colors to use for access to 1 bit map.  when reading one
 * bit map if (pixel & readbacl_mask == fgcolor.... bit = 1) 
 */

plxv_colors_1(p_me, fgcolor,bgcolor,readback_mask)
XV_struct* p_me;
{
    plxv_wf_done(p_me);
    /* if (pixel & readback_mask == fgcolor) then readback 1 */
    PV_WREG(p_me,M1ForCol.l,fgcolor);
    PV_WREG(p_me,M1BakCol.l,bgcolor);
    PV_WREG(p_me,M1RdMask.l,readback_mask);
    WBFLUSH;
}

#ifndef DRIVER

/* ^ ---------------------------------------------------------------------
 * set transparent mode for 1 bit operations.  forground color must have
 * bit-24 a 1 to write, bg color must have bit-24 a 0 to not write when
 * this mode is active.  (1's write fgcolor, 0's don't write at all    
 */

plxv_transp_on(p_me)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    PV_WREG(p_me,MMode.b.trans, 1);
    WBFLUSH;
}
#endif

/* ^ ---------------------------------------------------------------------
 * disable 1 bit transparent mode .... must do this if not in 1 bit map 
 */

plxv_transp_off(p_me)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    PV_WREG(p_me,MMode.b.trans,0);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * set special contrl register for 1 bit access.  
 * offset is a number 0-31 which determines the number of pixels
 *   to index into the longword of the 1 bit map. length determines the number
 *   of pixels the drawing (or reading) operation will do 
 */

plxv_ctl_1(p_me, offset,length)
    XV_struct* p_me;
{
    plxv_map_ctl(p_me, 0,length - 1,offset);
}

/* ^ ---------------------------------------------------------------------
 * a new routine to support the offsetting map hardware in all access modes 
 */

plxv_map_ctl(p_me, start,end,offset)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    PV_WREG(p_me,MStart.l,start);
    PV_WREG(p_me,MEnd.l,end);
    PV_WREG(p_me,MOffset.l,offset);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * **********************  drawing control  ****************************
 * WAIT FOR DONE:  can't use access maps while accelertor busy  
 * this routine waits for the accellerator to be done, and the fifo's empty 
 * must use this before any mode control changes, and after accell operations 
 */

plxv_wf_done(p_me)
    XV_struct* p_me;
{
    int i=1;
    int timer;

    PLXV_INHIBIT;

#ifdef mips

    wbflush();
    do {
	i = (volatile int) p_me->xv_rreg->DBusy.l;
    } while(i);

#else

    while (i) 
    {
	i= (volatile int) p_me->xv_rreg->DBusy.l;
    }
#endif
}

/* ^ ---------------------------------------------------------------------
 * 
 */

plxv_wf_done_uninhibited(p_me)
    XV_struct* p_me;
{
    int i;

#ifdef mips
    wbflush();
    do {
	i = (volatile int) p_me->xv_rreg->DBusy.l;
    } while(i);
#else
    i = 1;
    while (i) i= p_me->xv_rreg->DBusy.l;
#endif
}

/* ^ ---------------------------------------------------------------------
 * Sets the ROP type for all MAP access and accell operations 
 * normally set to COPY....   See plxv.h for all ROP modes    
 */

plxv_rop(p_me, rop)
    XV_struct* p_me;
{
    int sten_mask;

    plxv_wf_done(p_me);

    /* the parameter rop must repeat the selected operation over all
 	7 nybbles. eg. 0x5050505 for default setting */

    PV_WREG4(p_me, DrawRop.l,rop);
    
    rop_num = rop;
    if ((rop_num == PLXV_ROP_COPY) &&
	(stencil_mask == 0) &&
	((plxv_wmask_val & 0xff000000) == 0)) {
	   PV_WREG(p_me,RopCtl.b.rmw, 0);
    } else PV_WREG(p_me,RopCtl.b.rmw, 1);

    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * sets the write mask for all 28 bitplanes 1 bits enable writes to that bit,
 * 0 bits disable writes.  This overrides all tag & stensil modes.  NOTE:
 * video cycles can't ever write to the TAG planes (bits 24-27)		    
 */

plxv_wmask(p_me, val)
    XV_struct* p_me;
{
    int i;

    /* kludge code for now */
    if (is_28_now)
    {
	i = (val & 0xf000000) << 4;;
	val |= i;
    }
    
    plxv_wmask_val = val;     /* set write mask val */
    plxv_wf_done(p_me);
    PV_WREG(p_me,DrawMask.l,val);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * CONFIGURE the TAG value override control			  
 * when writing pixels the tag planes are determined by MUX & VAL 
 * if a bit in MUX is on then the corresponding bit in VAL is written 
 * instead of the source pixel value (from bus or blit) 
 * thus if MUX =0, the FIFO contents are written to the TAG 
 */

plxv_tag(p_me, mux,val)
    XV_struct* p_me;
{
    int i,j;

    plxv_wf_done(p_me);
    if ( is_28_now )
    {                            /* shift the bits to the right position */
	mux = (mux << 4) + mux;
	val = (val << 4) + val;
    }
    PV_WREG(p_me,TagCtl.b.ovr_mux,mux); 
    PV_WREG(p_me,TagCtl.b.ovr_val,val);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * Stencil decides on a pixel by pixel basis if a pixel is to written
 * to the memories.  if (PIXEL'S TAG & MASK) == VALUE, then write the pixel 
 */

plxv_stencil(p_me, mask,comp)
    XV_struct* p_me;
{
    stencil_mask = mask;
    plxv_wf_done(p_me);

    if ((rop_num == PLXV_ROP_COPY) &&
	(stencil_mask == 0) &&
	((plxv_wmask_val & 0xff000000) == 0)) {
	   PV_WREG(p_me,RopCtl.b.rmw, 0);
    } else PV_WREG(p_me,RopCtl.b.rmw, 1);

    if ( is_28_now ) {          /* shift the bits to the right position */
	mask = (mask << 4);
	comp = (comp << 4);
    }
    PV_WREG(p_me,TagClip.b.mask, mask);
    PV_WREG(p_me,TagClip.b.comp, comp);
    WBFLUSH;
}

/* ^ ---------------------------------------------------------------------
 * **********************  BOXES **********************************
 * draw a box starting at x0,y0.  size is sx,sy and must not be zero !! 
 * negaative sizes draw to left and up respectively		        
 */

plxv_box(p_me, x0,y0,sx,sy)
    XV_struct* p_me;
{
    int addr;
    int wm,dy;


#ifdef NARROW_BOX_BUG
    register int absx, xinc;

    if(sx < 0) { absx= -sx; xinc= -1; }
    else       { absx= sx;  xinc=  1; }

#if defined(mips) || defined(__hpux) || defined(_AIX)
    if((absx > 1) && (absx < 5))
#else
    if (absx == 3)	/* could do a 2 then a 1, but why bother? */
#endif
    {
	register int i,j;

	j = x0;
	for(i = absx; i--;)
	{
	    plxv_box(p_me, j, y0, 1, sy);
	    j += xinc;
	}
	return;
    }
#endif

    addr = PLXV_ADDR_REG(p_me, x0,y0);
    if (sx == 0 || sy == 0) return(0);
    plxv_wf_done(p_me);

    switch (p_me->main.ga_rev) 
    {                               /* fix a GA bug on box vertical size */
      case GAREV_2:               
    	dy = ((sy<0) ? -1 : 1);		/* get abs of sy */
	wm = plxv_wmask_val;		/* save old write mask */
	plxv_wmask(p_me, 0);			/* set temp mask to zeo */
	p_me->xv_wreg->DstW.l = 0;		/* draw a bogus vector  */
	CacheFlush;
	p_me->xv_wreg->VectDY.l = dy;
	CacheFlush;
	plxv_vector_done(p_me);		/* wait for done	*/
	plxv_wmask(p_me, wm);			/* then, restore write mask */
	break;
      default:
	break;
    }
    p_me->xv_wreg->SolidCol.l = plxv_accel_color;
	CacheFlush;
    PV_WREG(p_me,DstStartAdd.l, addr);
    p_me->xv_wreg->DstW.l = sx;
	CacheFlush;
    p_me->xv_wreg->DstH.l = sy;
	CacheFlush;
    plxv_wf_done(p_me);
}

/********
int
TestHwr()
{
	int i;
	if (!TestHwrWord(0)) return(0);
	if (!TestHwrWord(-1)) return(0);
	if (!TestHwrWord(0x480)) return(0);
	for (i=0; i<32; i++) {
	    if (!TestHwrWord(1<<i)) return(0);
	    if (!TestHwrWord(~(1<<i))) return(0);
	}
	return(1);
}	
TestHwrWord(x)
int x;
{
    int i;
    PV_WREG(p_me,TmrInt.l,x);
	for (i=0; i<10; i++);
    PV_RREG(p_me,i,TmrIntRB.l);
    if (x!=i) {
	printf("Data Bus Error: wrote %x read %x\n",x,i);
	exit(1);
	return (0);
    }
    return (1);
}
*/

/* ^ ---------------------------------------------------------------------
 * copy a box starting at xs,sys to x0,y0..... size sx,sy		
 * if sizes are negative, then proceed to left (up)			
 * mirroring is not supported						
 */

plxv_blit(p_me, xs,ys,x0,y0,sx,sy)  /* point xs,ys copies to x0,y0 */
XV_struct* p_me;
{
    int addrS,addrD;
    int dy,wm;

    if (sx == 0 || sy == 0) return(0);

    addrS = PLXV_ADDR_REG(p_me, xs,ys);
    addrD = PLXV_ADDR_REG(p_me, x0,y0);
    if (sx < 0)
    {
#ifdef sun
	if (( xs & 0x3) > (x0 & 3 )) addrS +=4;
#else
	if (( xs % 5) > ( x0 % 5)) addrS += 5;
#endif
    }
    plxv_wf_done(p_me);

    switch (p_me->main.ga_rev)
    {  /* fix a GA bug on box vertical size */
      case GAREV_2:
    	dy = ((sy<0) ? -1 : 1);	/* get abs of sy */
	wm = plxv_wmask_val;		/* save old write mask */
	plxv_wmask(p_me, 0);		/* set temp mask to zeo */
	p_me->xv_wreg->DstW.l = 0;		/* draw a bogus vector  */
	CacheFlush;
	p_me->xv_wreg->VectDY.l = dy;
	CacheFlush;
	plxv_wf_done(p_me);			/* wait for done	*/
	plxv_wmask(p_me, wm);		/* then, restore write mask */
	break;
      default:
	break;
    }

    /* do the normal code for blit */
    PV_WREG(p_me,SrcStartAdd.l, addrS);
    PV_WREG(p_me,DstStartAdd.l, addrD);
    p_me->xv_wreg->DstW.l = sx;
	CacheFlush;
    p_me->xv_wreg->DstH.l = sy;
	CacheFlush;
    plxv_wf_done(p_me);
}

/* ^ ---------------------------------------------------------------------
 * **************************** VECTORS *********************************
 */

plxv_vector_done(p_me)
    XV_struct* p_me;
{
    int i=1;
    int timeout;

#ifdef mips

    wbflush();
    do {
	i = (volatile int) p_me->xv_rreg->VBusy.l;
    } while(i);

#else

    while (i) { PV_RREG(p_me,i,VBusy.l) }

#endif
}

#ifndef DRIVER 

/* ^ ---------------------------------------------------------------------
 * if set then graphics accellerator will draw last pixels on vectors 
 */

plxv_vect_last(p_me, nlast)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    nlast &= 0x1;
}

#endif

/* ^ ---------------------------------------------------------------------
 */

plxv_vector_window(p_me, x,y)
    XV_struct* p_me;
{
    PLXV_INHIBIT;
    p_me->xv_wreg->WindowX.l = x;
	CacheFlush;
    p_me->xv_wreg->WindowY.l = y;
	CacheFlush;
    WBFLUSH;
}

#ifndef DRIVER

/* ^ ---------------------------------------------------------------------
 * Draw a vector starting at x0,y0.
 * dx and dy arr DELTAS to final pixel  of the vector  
 */

plxv_vector_abs(p_me, x0,y0,x1,y1)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    p_me->xv_wreg->SolidCol.l = plxv_accel_color;
	CacheFlush;
    p_me->xv_wreg->VectX0.l = x0;
	CacheFlush;
    p_me->xv_wreg->VectY0.l = y0;
	CacheFlush;
    p_me->xv_wreg->VectX1.l = x1;
	CacheFlush;
    p_me->xv_wreg->VectY1.l = y1;
	CacheFlush;
    plxv_vector_done(p_me);
}

/* ^ ---------------------------------------------------------------------
 */

plxv_vector(p_me, x0,y0,dx,dy)
    XV_struct* p_me;
{
    plxv_vector_rel(p_me, x0,y0,dx,dy);
}

/* ^ ---------------------------------------------------------------------
 */

plxv_vector_rel(p_me, x0,y0,dx,dy)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    p_me->xv_wreg->SolidCol.l = plxv_accel_color;
	CacheFlush;
    p_me->xv_wreg->VectX0.l = x0;
	CacheFlush;
    p_me->xv_wreg->VectY0.l = y0;
	CacheFlush;
    plxv_vector_done(p_me);
    p_me->xv_wreg->DstW.l = dx;
	CacheFlush;
    p_me->xv_wreg->VectDY.l = dy;
	CacheFlush;
    plxv_vector_done(p_me);
}

/* ^ ---------------------------------------------------------------------
 */

plxv_vector_cont(p_me, dx,dy)
    XV_struct* p_me;
{
   plxv_vector_cont_rel(p_me, dx,dy);
} 

/* ^ ---------------------------------------------------------------------
 */

plxv_vector_cont_rel(p_me, dx,dy)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    p_me->xv_wreg->DstW.l = dx; 
	CacheFlush;
    p_me->xv_wreg->VectDY.l = dy; 
	CacheFlush;
    plxv_vector_done(p_me);
}

/* ^ ---------------------------------------------------------------------
 */

plxv_vector_cont_abs(p_me, x1,y1)
    XV_struct* p_me;
{
    plxv_wf_done(p_me);
    p_me->xv_wreg->VectX1.l = x1; 
	CacheFlush;
    p_me->xv_wreg->VectY1.l = y1; 
	CacheFlush;
    plxv_vector_done(p_me);
}

/* ^ ---------------------------------------------------------------------
 * all colors are 28 bit (include tag data 
 * how to vector:
 * load rop,stencil, plane mask, etc
 * set color
 * load start address
 * load i1, i2, e
 * set number of pixels, flags, and major_axis
 * wait for done
 * preceed uncooked vectors with a 'null' cooked vector to prime mode
 */

plxv_vector_uncook(p_me, x0,y0,num_pix,i1,i2,e,left_flag,up_flag,x_major_flag)
    XV_struct* p_me;
{
    int i,addr, temp;

    plxv_wf_done(p_me);

    addr = PLXV_ADDR_REG(p_me, x0,y0);
    p_me->xv_wreg->SolidCol.l = plxv_accel_color;
	CacheFlush;

#if GA_REV == GAREV_1
    temp = plxv_wmask_val;		/* save the mask value */
    plxv_wmask(p_me, 0);			/* so we don't draw anything */
    p_me->xv_wreg->DstStartAdd.l = addr;
	CacheFlush;
    p_me->xv_wreg->DstW.l = 0;
	CacheFlush;
    p_me->xv_wreg->VecH.l = 1;		/* NOTE must not be horizontal */
	CacheFlush;
    plxv_wf_done(p_me);
    plxv_wmask(p_me, temp);			/* put the mask back */
#endif

    p_me->xv_wreg->VecI1.l = i1;              /* now do the real vector */
	CacheFlush;
    p_me->xv_wreg->VecI2.l = i2;
	CacheFlush;
    p_me->xv_wreg->VecAcc.l = e;
	CacheFlush;

    PV_WREG(p_me,DstStartAdd.l, addr);

    i  = ((x_major_flag & 1) << 15) | ((up_flag  & 1) << 14);
    i |= ((left_flag & 1) <<13) | (num_pix & 0xfff);
    p_me->xv_wreg->VecMsc.l = i;
	CacheFlush;
    plxv_wf_done(p_me);
}

/* ^ ---------------------------------------------------------------------
 * ****************** parameter vector stuff ******************** 
 */

plxv_pvector(p_me, x0,y0,dx,dy)
    XV_struct* p_me;
{
    plxv_pvector_rel(p_me, x0,y0,dx,dy);
}

/* ^ ---------------------------------------------------------------------
 */

#ifdef major
#undef major
#undef minor
#endif

plxv_pvector_rel(p_me, x0,y0,dx,dy)
    XV_struct* p_me;
{
    int i,i1,i2,e,left=0,up=0,major,minor,xmajor,len,addr;
    int nofirst=1,a;

    if (dx < 0) {
	left = 1;
	dx = -dx;
    }
    if (dy < 0) {
	up = 1;
	dy = -dy;
    }
    if (dx >= dy) {
	major = dx;
	minor = dy;
	xmajor = 1;
    } else {
	major = dy;
	minor = dx;
	xmajor = 0;
    }

    i1 = 2 * minor;
    i2 = 2 * (minor - major);
    e = (2 * minor) - major;
    len = major;
    addr = PLXV_ADDR_REG(p_me, x0,y0);
    
    plxv_wf_done(p_me);
    p_me->xv_wreg->SolidCol.l = plxv_accel_color;
	CacheFlush;

    p_me->xv_wreg->VecI1.l = i1;
	CacheFlush;
    p_me->xv_wreg->VecI2.l = i2;
	CacheFlush;
    p_me->xv_wreg->VecAcc.l = e;
	CacheFlush;

    PV_WREG(p_me,DstStartAdd.l, addr);

    a = (len) | (nofirst << 12) | (left  << 13) | 
		(up  << 14) | (xmajor << 15);
    p_me->xv_wreg->VecMsc.l = a;
	CacheFlush;
    plxv_wf_done(p_me);
}

#ifdef excluded

/* ^ ---------------------------------------------------------------------
 * all colors are 28 bit (include tag data 
 * how to vector:
 * load rop,stencil, plane mask, etc
 * set color (already done)
 * load start address (already done)
 * load i1, i2, e
 * set number of pixels, flags, and major_axis
 * wait for done
 * this routine is not responsible for setting up the drawing modes 
 */

continue_uncooked_vector(p_me, i1,i2,e,num_pixel,left_flag,up_flag, x_major)
    XV_struct* p_me;
{
    int i;

    PV_WREG(p_me,VecI1.l, i1);
    PV_WREG(p_me,VecI2.l, i2);
    PV_WREG(p_me,VecAcc.l, e);
    i = (x_major << 15) | (up_flag << 14) | (left_flag <<13) | num_pixel;
    PV_WREG(p_me,VecMsc.l, i);
    plxv_wf_done(p_me);
}

#endif /* excluded */

#endif /* !DRIVER */
