/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log:   /plxhp/dave/source/hwlib/archives/vidlib.c_v  $
 * 
 *    Rev 1.6   14 Sep 1996 13:07:48   dave
 * adjusted y values for v and w squeeze live
 * 
 *    Rev 1.5   09 Sep 1996 10:15:40   dave
 * made things more context correct (multiboard).
 * Revision 1.5  1996/07/22 20:02:46  dave
 * made things more context correct (multiboard).
 *
 * Revision 1.4  96/04/20  00:10:00  00:10:00  dist (Software Distribution Account)
 * fixed an uninited variable
 * 
 * Revision 1.3  1995/12/08  13:47:49  dist
 * Andy Goodrich: Sun (hedge), HP and IBM combined library.
 *
 * Revision 1.2  95/05/25  17:09:31  17:09:31  dist ()
 * Andy Goodrich - HP 9.1 Code Freeze version
 * 
 * Revision 1.17  92/08/21  16:17:04  rocky
 * added missing break in switch statement
 * 
 * Revision 1.16  92/05/05  11:05:29  kau
 * fix bottom first pixel replication on output
 * 
 * Revision 1.15  91/11/26  13:57:02  kau
 * wait for video_added but not yet working!!!
 * 
 * Revision 1.14  91/10/23  09:56:01  mears
 * new rev
 * 
 * 
 * Revision 1.13  91/10/04  12:47:36  mears
 * ifdef DRIVER
 * 
 * Revision 1.12  91/09/30  16:32:09  mears
 * changes in stopping digitization
 * 
 * Revision 1.11  91/08/20  20:37:06  mears
 * added loopback format
 * 
 * Revision 1.10  91/08/15  19:36:23  eric
 * debugging prints
 * 
 * Revision 1.9  91/08/15  18:20:45  mears
 * use standard numbers for digitization start location
 * 
 * Revision 1.8  91/08/14  12:24:20  mears
 * blanking info in nvram
 * 
 * Revision 1.7  91/08/13  14:35:20  mears
 * right fix for starline
 * 
 * Revision 1.6  91/08/13  14:22:38  eric
 * need to set startline anyway
 * 
 * Revision 1.5  91/08/13  13:45:28  mears
 * disable output when w used for input
 * 
 * Revision 1.4  91/08/06  10:38:11  eric
 * turn output on and off
 * 
 * Revision 1.3  91/07/27  14:05:52  eric
 * less debugging
 * 
 * Revision 1.2  91/07/26  19:07:01  eric
 * new from bill
 * 
 * Revision 1.1  91/06/12  16:06:34  eric
 * Initial revision
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: vidlib.c,v 1.5 1996/07/22 20:02:46 dave Exp $ Parallax Graphics Inc";
#endif

#include <stdio.h> /* #### */
#ifdef AIX
#include <sys/inline.h>
#endif
#include "hw_context.h"
#include "plxv_xpoint.h"

#define NULL 0
#define INPUT 0
#define OUTPUT 1

#define WAIT_FOR_V 0
#define WAIT_FOR_W 1
#define WAIT_FOR_FIRST 2
#define WAIT_FOR_BOTH 3

#define XV_DIAG 1
#include "../include/xvdebug.h"

#ifndef DRIVER
extern int is_28_now = 0;
#if 0
static int Vaddr = 0;

static int gdsy_v=0,gdsy_w=0;
static int waddr = 0;

static w_last_funct = OUTPUT;
#endif
#endif

#ifdef AIX
#define Cache_Flush eieio()
#else
#define Cache_Flush
#endif

/* initialize the video input hardware and crosspoint switch.  Set both
   V and W channels to recieve the onboard D channel.  Set DMSD for NTSC
   mode, and turn off flashing NOW					 */
plxv_init_video(p_me)
    XV_struct* p_me;
{
/* squash */
	switch( p_me->main.board_code )
	{
	  case SBUS_6:
		break;
	  case SBUS_4:
	  case EISA_BUS_1_135:
	  case EISA_BUS_1_108:
	  case EISA_BUS_1_84:
	  case EISA_BUS_1_64:
		p_me->xv_wreg->VFormat.l = 0;
		Cache_Flush;
		p_me->xv_wreg->WFormat.l = 0;
		Cache_Flush;
		break;
      default: 
		p_me->xv_wreg->VFormat.l = SEL_DATA_INPUT_D | SEL_CTL_INPUT_D |
				 SEL_CLK_INPUT_D | SEL_CLK_HIGH;
		Cache_Flush;
		p_me->xv_wreg->WFormat.l = SEL_DATA_INPUT_D | SEL_CTL_INPUT_D |
				 SEL_CLK_INPUT_D | SEL_CLK_HIGH;
		Cache_Flush;
		break;
    }

    /* stop flashing on both ports NOW */
    PV_WREG(p_me,VCtl.b.now,1);
    PV_WREG(p_me,WCtl.b.now,1);
    PV_WREG(p_me,VCtl.b.single,0);
    PV_WREG(p_me,WCtl.b.single,0);
    PV_WREG(p_me,VCtl.b.cont,0);
    PV_WREG(p_me,WCtl.b.cont,0);

    plxv_flash_v_off(p_me);
    plxv_flash_w_off(p_me);

    /* new stuff hacked in !!! */
    p_me->xv_wreg->VStart.l = 4;
	Cache_Flush;
    p_me->xv_wreg->VStop.l  = 260;
	Cache_Flush;
    p_me->xv_wreg->WStart.l = 4;
	Cache_Flush;
    p_me->xv_wreg->WStop.l  = 260;
	Cache_Flush;

#ifndef DRIVER
    plxv_init_attr(p_me);
#endif
}

/****************************  WRITE CONTROL STUFF  *****************/

#ifndef DRIVER

/* set up the stencil control for the V channel.  each pixel of destination
   is read for TAG value.  if (pixel's tag & mask) = value, then write the
   video pxiel to memory						   */
plxv_video_v_stencil(p_me, mask,compare)
    XV_struct* p_me;
int mask,compare;
{
    /* draw video v only when (tagplanes & mask) == compare */
    if ( is_28_now)
    {
	 mask = ((mask & 0xf) << 4);
	 compare  = ((compare  & 0xf) << 4);
    }
    PV_WREG(p_me,VTag.b.val, compare);
    PV_WREG(p_me,VTag.b.mask, mask);
}

/* setup the write mask for the V channel. Note: you can't write to the
   TAG planes from the video inputs					  */
plxv_video_v_wmask(p_me, mask)
    XV_struct* p_me;
int mask;
{
    /* mask is a 24-bit value since tag planes are not affedted */
    PV_WREG(p_me,VMask.l, mask);
}

#endif /* NOT DRIVER */

/* TURN OFF the FLASH on V... but wait until the current field is done	  */
plxv_flash_v_off(p_me)
    XV_struct* p_me;
{
    PV_WREG(p_me,VCtl.l, 0);
}

#ifndef DRIVER

/* TURN OFF the FLASH on V... NOW */
plxv_flash_v_off_now(p_me)
    XV_struct* p_me;
{
    PV_WREG(p_me,VCtl.l, 0x80808);
}

/* set up the stencil control for the W channel.  each pixel of destination
   is read for TAG value.  if (pixel's tag & mask) = value, then write the
   video pxiel to memory						   */
plxv_video_w_stencil(p_me, mask,compare)
    XV_struct* p_me;
int mask,compare;
{
    /* draw video w only when (tagplanes & mask) == compare */
    if ( is_28_now)
    {
	 mask = ((mask & 0xf) << 4);
	 compare  = ((compare  & 0xf) << 4);
    }
    PV_WREG(p_me,WTag.b.val, compare);
    PV_WREG(p_me,WTag.b.mask, mask);
}

/* setup the write mask for the W channel. Note: you can't write to the
   TAG planes from the video inputs					  */
plxv_video_w_wmask(p_me, mask)
    XV_struct* p_me;
int mask;
{
    /* mask is a 24-bit value since tag planes are not affedted */
    PV_WREG(p_me,WMask.l, mask);
}

#endif

/* TURN OFF the FLASH on W... but wait until the current field is done	  */
plxv_flash_w_off(p_me)
    XV_struct* p_me;
{
    int i;

#ifndef DRIVER
    /* turn off the option cards display */
    /* in case it has been gernerating an output */
    if (p_me->opt.board_code)
    {
	    p_me->plxv_opt_cntl_reg &= ~0x8;
	    PV_WREG(p_me,Ext.reg2,p_me->plxv_opt_cntl_reg);
    }
#endif

    /* don't clear the direction bit */
    PV_RSDW(p_me,i,WCtl.l);
    i &= ~0x60606;
    PV_WREG(p_me,WCtl.l, i);

}

#ifndef DRIVER
/* TURN OFF the FLASH on W... NOW !! (don't hit the direction bits   */
plxv_flash_w_off_now(p_me)
    XV_struct* p_me;
{
    int i;
    /* turn off the option cards display */
    /* in case it has been gernerating an output */
    if (p_me->opt.board_code)
    {
	    p_me->plxv_opt_cntl_reg &= ~0x8;
	    PV_WREG(p_me,Ext.reg2,p_me->plxv_opt_cntl_reg);
    }

    /* don't clear the direction bit */
    PV_RSDW(p_me,i,WCtl.l);
    i &= ~0x60606;
    i |= 0x80808;
    PV_WREG(p_me,WCtl.l, i);

}
/****************************   FLASH COMMANDS   *******************/

/* digitize on the V channel an unsqueezed image */
/* user is responsible for setting up tag/wm and clipping */
plxv_flash_v(p_me, dx,dy)
    XV_struct* p_me;
int dx,dy;
{
	 plxv_flash_v_squeeze(p_me, -4,44,640,480,(dx),(dy),640,480,0,0);
}
/* digitize on the W channel an unsqueezed image */
/* user is responsible for setting up tag/wm and clipping */
plxv_flash_w(p_me, dx,dy)
    XV_struct* p_me;
int dx,dy;
{
	 plxv_flash_w_squeeze(p_me, -4,44,640,480,(dx),(dy),640,480,0,0);
}

/*  flash squeezed  vx,vy are positions in input space		 */
/*		    vsy,vsy are sizes in pixels from input space */
/*		    dx,dy are frame buffer coordiantges		 */
/*		    dsx,dsy are sizes in pixels on display	 */
/*		    noninterlace is a zero for an interlaced img */
/*		    "single" starts flash, but doesn't wait until done */
/*	flashing image will spill outside region of display	 */
/*	clipping is required to control actual region of flashing */
/*	programmer is responsible for correctly clipping with tags */

plxv_flash_v_squeeze(p_me, vx,vy,vsx,vsy,dx,dy,dsx,dsy,noninterlace,single)
    XV_struct* p_me;
int vx,vy,vsx,vsy,dx,dy,dsx,dsy,noninterlace;
{

    int i,k,sqzx,sqzy;
    int ddx,ddy,instr;
    int startline,stopline,dead_lines;
    int overflow = 0;

    p_me->gdsy_v = dsy;

#ifdef hpux
    dy += 3;
#endif

    /* use the vstart and vstop registers to position the vertical */
    if (*p_me->format_v_ptr == NULL)
    {
	printf("plxv_flash_v: attempt to flash from null format\n");
	p_me->format_v_ptr = &(p_me->plxv_io_format[LOOPBACK]);
    }
    dead_lines = (*p_me->format_v_ptr)->reset_line;
    startline  = ( noninterlace ?  vy : vy>>1) - dead_lines;
    if (startline < 1 )
    {	/* need to draw a black box where we can't digitize */
	overflow = 1-startline;
	startline = 1;
    }
    vy -= (noninterlace ? 1:2 ) * (dead_lines - overflow);
	
    stopline = startline -overflow + (noninterlace ? vsy  : ((vsy +1)>>1) );
    p_me->xv_wreg->VStart.l = startline;
	Cache_Flush;
    p_me->xv_wreg->VStop.l = stopline;
	Cache_Flush;

    if ((sqzx = plxv_calc_squeeze(p_me, vsx,dsx)) < 0) return(-1);
    if ((sqzy = plxv_calc_squeeze(p_me, vsy,dsy)) < 0) return(-1);

    if (dsx < 0 ) i=1; else i=0;
    if (dsy < 0 ) k=0; else k=1;

    ddx = (vx * (sqzx + 1))>>12;
    ddy = (vy * (sqzy + 1))>>12;
    p_me->Vaddr = PLXV_ADDR_REG(p_me, dx,dy) - (ddy * p_me->main.linebytes) - ddx;

    if (p_me->Vaddr < 0) p_me->Vaddr += p_me->addr_wrap;

    PV_WREG(p_me,VSqzY.b.factor, sqzy);
    PV_WREG(p_me,VSqzY.b.inter, noninterlace);
    PV_WREG(p_me,VSqzY.b.ltor, i);
    PV_WREG(p_me,VSqzY.b.ttob, k);

    
    PV_WREG(p_me,VSqzX.b.factor, sqzx);
    PV_WREG(p_me,VSqzX.b.ltor, i);
    p_me->xv_wreg->VStartAdd.l = p_me->Vaddr;
	Cache_Flush;


    if (single)
    {
	PV_WREG4(p_me,VCtl.l, 2);
    }
    else PV_WREG4(p_me, VCtl.l, 4);
}

plxv_flash_w_squeeze(p_me, vx,vy,vsx,vsy,dx,dy,dsx,dsy,noninterlace,single)
    XV_struct* p_me;
int vx,vy,vsx,vsy,dx,dy,dsx,dsy,noninterlace,single;
{
    int a,i,k,addr,sqzx,sqzy;
    int ddx,ddy;
    int startline,stopline,dead_lines;
    int overflow = 0;

    p_me->gdsy_w = dsy;

#ifdef hpux
    dy += 3;
#endif

    if (p_me->w_last_funct != INPUT)
    {
	plxv_flash_w_off_now(p_me);
	p_me->w_last_funct = INPUT;

        /* turn off the option cards display */
        /* in case it has been gernerating an output */
        if (p_me->opt.board_code)
        {
	    p_me->plxv_opt_cntl_reg &= ~0x8;
	    PV_WREG(p_me,Ext.reg2,p_me->plxv_opt_cntl_reg);
        }
    }

    /* use the vstart and vstop registers to position the vertical */
    if (*p_me->format_w_ptr == NULL)
    {
	printf("plxv_flash_w: attempt to flash from null format\n");
	p_me->format_w_ptr = &(p_me->plxv_io_format[LOOPBACK]);
    }

    dead_lines = (*p_me->format_w_ptr)->reset_line;
    startline  = ( noninterlace ?  vy : vy>>1) - dead_lines;
    if (startline < 1 )
    {	/* need to draw a black box where we can't digitize */
	overflow = 1-startline;
	startline = 1;
    }
    vy -= (noninterlace ? 1:2 ) * (dead_lines - overflow);
	
    stopline = startline - overflow + (noninterlace ? vsy  : ((vsy +1)>>1) );
    p_me->xv_wreg->WStart.l = startline;
	Cache_Flush;
    p_me->xv_wreg->WStop.l  = stopline;
	Cache_Flush;

    if ((sqzx = plxv_calc_squeeze(p_me, vsx,dsx)) < 0) return(-1);
    if ((sqzy = plxv_calc_squeeze(p_me, vsy,dsy)) < 0) return(-1);

    if (dsx < 0 ) i=1; else i=0;
    if (dsy < 0 ) k=0; else k=1;

    ddx = (vx * (sqzx + 1))>>12;
    ddy = (vy * (sqzy + 1))>>12;
    addr = PLXV_ADDR_REG(p_me, dx,dy) - (ddy * p_me->main.linebytes) - ddx;
    if (addr < 0) addr += p_me->addr_wrap;

    /* turn off the option cards display */
    /* in case it has been gernerating an output */
    if (p_me->opt.board_code)
    {
	    p_me->plxv_opt_cntl_reg &= ~0x8;
	    PV_WREG(p_me,Ext.reg2,p_me->plxv_opt_cntl_reg);
    }

    PV_WREG(p_me,WSqzY.b.factor, sqzy);
    PV_WREG(p_me,WSqzY.b.inter, noninterlace);
    PV_WREG(p_me,WSqzY.b.ltor, i);
    PV_WREG(p_me,WSqzY.b.ttob, k);

    
    PV_WREG(p_me,WSqzX.b.factor, sqzx);
    PV_WREG(p_me,WSqzX.b.ltor, i);

    PV_WREG(p_me,WStartAdd.l,addr);
	p_me->waddr = addr;
    p_me->xv_wreg->VStartAdd.l = p_me->Vaddr;		/* fixed l.to.r bug */
	Cache_Flush;

    if (single)
    {
	PV_WREG4(p_me, WCtl.l, 2);
    }
    else PV_WREG4(p_me, WCtl.l,4);

}
/* generate output stream on w channel */
/* sx,sy are the source coordinates in the frame buffer */
/* address pointers reset/advance on Vsync/Hsync respectively */
/* ssx & ssy are frame buffer window size in pixels, negative */
/* sizes are for left going and upgoing .  vx & vy refer to the */
/* video destination coordinates Y is relative to vsync in hsynces */
/* and X is relative to unblanked video.  vsx and vsy are */
/* sizes in pixels  for expand factors only. If they don't match */
/* the video output, then the data you get is accurate only to */
/* the expand factor */

plxv_output_w(p_me, sx,sy,ssx,ssy,vx,vy,vsx,vsy,noninterlace,single)
    XV_struct* p_me;
int sx,sy,ssx,ssy,vx,vy,vsx,vsy,noninterlace,single;
{
    int a,i,k,addr,sqzx,sqzy;
    int ddx,ddy;

    int startline,stopline,dead_lines,stop_offset;
    int overflow = 0;

    stop_offset = 0;
    p_me->gdsy_w = ssy;
    if (p_me->w_last_funct != OUTPUT)
    {
	plxv_flash_w_off_now(p_me);
	p_me->w_last_funct = OUTPUT;
    }

    /* use the vstart and vstop registers to position the vertical */
    if (*p_me->format_w_ptr == NULL)
    {
	printf("plxv_output_w: attempt to output to null format\n");
	p_me->format_w_ptr = &(p_me->plxv_io_format[LOOPBACK]);
    }
    dead_lines = (*p_me->format_w_ptr)->reset_line;
    switch (p_me->opt.board_rev)
    {
	case 0: 
#ifdef sun
	    dead_lines -= 4;
#endif
	    break;
	case 1: 
	    dead_lines -= 3;
	    stop_offset = 3;
	    break;
	default:
	    break;
    }
    startline  = ( noninterlace ?  vy : vy>>1) - dead_lines;
    if (startline < 1 )
    {
	overflow = 1-startline;
	startline = 1;
    }
    vy -= (noninterlace ? 1:2 ) * (dead_lines - overflow);
	
    stopline = startline -overflow + (noninterlace ? vsy  : ((vsy +1)>>1))
		+ stop_offset;
    p_me->xv_wreg->WStart.l = startline;
	Cache_Flush;
    p_me->xv_wreg->WStop.l  = stopline;
	Cache_Flush;

    if ((sqzx = plxv_calc_squeeze(p_me, vsx,ssx)) < 0) return(-1);
    if ((sqzy = plxv_calc_squeeze(p_me, vsy,ssy)) < 0) return(-1);

    if (ssx < 0 ) i=1; else i=0;
    if (ssy < 0 ) k=0; else k=1;

    ddx = (vx * (sqzx + 1))>>12;
    ddy = (vy * (sqzy + 1))>>12;
    addr = PLXV_ADDR_REG(p_me, sx,sy) - (ddy * p_me->main.linebytes) - ddx;
    if (addr < 0) addr += p_me->addr_wrap;

    PV_WREG(p_me,WSqzY.b.factor, sqzy);
    PV_WREG(p_me,WSqzY.b.inter, noninterlace);
    PV_WREG(p_me,WSqzY.b.ltor, i);
    PV_WREG(p_me,WSqzY.b.ttob, k);

    
    PV_WREG(p_me,WSqzX.b.factor, sqzx);
    PV_WREG(p_me,WSqzX.b.ltor, i);

    p_me->xv_wreg->WStartAdd.l = addr;
	Cache_Flush;
    p_me->xv_wreg->VStartAdd.l = p_me->Vaddr;		/* fixed l.to.r bug */
	Cache_Flush;

    if (single)
    {
	PV_WREG4(p_me, WCtl.l, 3);
    }
    else PV_WREG4(p_me, WCtl.l,5);
}

int plxv_wf_video(p_me, chan,line)
    XV_struct* p_me;
int chan,line;
{
    int iv_curadd,iw_curadd;
    int vsingle,wsingle;
    int vstart_flag,wstart_flag;
    int i=0,j=0;

    PV_RSDW(p_me,vsingle,VCtl.b.single);
    PV_RSDW(p_me,wsingle,WCtl.b.single);

    switch (chan)
    {
	case WAIT_FOR_V:
    	    iv_curadd = uncalc_v(p_me, line);
	    if (vsingle)
	        while (compare_video_curadd_v(p_me, iv_curadd));
	    else
	    {
		while (~compare_video_curadd_v(p_me, iv_curadd)); /* wait for above */
		while (compare_video_curadd_v(p_me, iv_curadd)); /* wait for done */
	    }
	    return(WAIT_FOR_V);
	    break;
	case WAIT_FOR_W:
    	    iw_curadd = uncalc_w(p_me, line);
	    if (wsingle)
	        while (compare_video_curadd_w(p_me, iw_curadd));
	    else
	    {
		while (~compare_video_curadd_w(p_me, iw_curadd)); /* wait for above */
		while (compare_video_curadd_w(p_me, iw_curadd)); /* wait for done */
	    }
	    return(WAIT_FOR_W);
	    break;
	case WAIT_FOR_FIRST:
    	    iv_curadd = uncalc_v(p_me, line);
    	    iw_curadd = uncalc_w(p_me, line);
	    vstart_flag = 1;
	    wstart_flag = 1;
	    {
		while (1)
		{
		    {
		        if (vsingle)
		        {
			    if (compare_video_curadd_v(p_me, iv_curadd))
				return(WAIT_FOR_V);
			}
		        else	
			{
		            if (vstart_flag) 
			        vstart_flag = compare_video_curadd_v(p_me, iv_curadd);
		            else if (compare_video_curadd_v(p_me, iv_curadd))
			        return(WAIT_FOR_V);
			}
		        if (wsingle)
		        {
		            if (compare_video_curadd_w(p_me, iw_curadd))
			        return(WAIT_FOR_W);
			}
			else
			{
		            if (wstart_flag) 
			        wstart_flag = compare_video_curadd_w(p_me, iw_curadd);
		            else if (compare_video_curadd_w(p_me, iw_curadd))
			        return(WAIT_FOR_W);
			}
		    }
		}
	    }
	    break;
	case WAIT_FOR_BOTH:
    	    iv_curadd = uncalc_v(p_me, line);
    	    iw_curadd = uncalc_w(p_me, line);
	    {
		while ((i & j) == 0)
		{
		    if (i == 0)
		    {
			if (vsingle)
		            i = compare_video_curadd_v(p_me, iv_curadd);
		        else	
			{
		            if (vstart_flag) 
			        vstart_flag = compare_video_curadd_v(p_me, iv_curadd);
		            else 
				i = compare_video_curadd_v(p_me, iv_curadd);
			}
		    }
		    if (j == 0)
		    {
			if (wsingle)
			    j = compare_video_curadd_w(p_me, iw_curadd);
			else
			{
		            if (wstart_flag) 
			        wstart_flag = compare_video_curadd_w(p_me, iw_curadd);
		            else if (compare_video_curadd_w(p_me, iw_curadd))
			        return(WAIT_FOR_W);
			}
		    }
		}
		return(WAIT_FOR_BOTH);
	    }
	    break;
		
	default:
	    printf("invalid wait_for_video function call\n");
	    break;
    }
}

int uncalc_v(p_me, line)
XV_struct* p_me;
int line;
{
    int i,xsize,ttob;

    PV_RSDW(p_me,ttob,VSqzY.b.ttob);
    xsize = p_me->main.linebytes;
    
    if (ttob)
    {
        if (line < 0)
	    i = p_me->Vaddr + (p_me->gdsy_v + line - 1) * xsize/4;
        else
	    i = p_me->Vaddr + line * xsize/4;
    }
    else
    {
	if (line < 0)
	    i = p_me->Vaddr + line * xsize/4;
	else
	    i = p_me->Vaddr + (p_me->gdsy_v + line - 1) * xsize/4;
    }
    i &= 0x3ffff;
    return(i);
}

int uncalc_w(p_me, line)
XV_struct* p_me;
int line;
{
    int i,xsize,ttob;

    PV_RSDW(p_me,ttob,WSqzY.b.ttob);
    xsize = p_me->main.linebytes;
    
    if (ttob)
    {
        if (line < 0)
	    i = p_me->waddr + (p_me->gdsy_w + line - 1) * xsize/4;
        else
	    i = p_me->waddr + line * xsize/4;
    }
    else
    {
	if (line < 0)
	    i = p_me->Vaddr + line * xsize/4;
	else
	    i = p_me->Vaddr + (p_me->gdsy_w + line - 1) * xsize/4;
    }
    i &= 0x3ffff;
    return(i);
}

compare_video_curadd_v(p_me, curadd)
XV_struct* p_me;
int curadd;
{
    int i,j;
    int ttob,factor,odd;

    PV_RSDW(p_me,ttob,VSqzY.b.ttob);
    PV_RSDW(p_me,factor,VSqzY.b.factor);

    PV_RREG(p_me,i,VCurAdd.l);
    PV_RREG(p_me,j,IntStat.l);
    odd = (j >> 8) & 1;

    if ((factor > 0x7ff) && odd)	/* 1 <= squeeze_factor < 2 */
	return(0);	
    i &= 0x3ffff;
    curadd &= 0x3ffff;
    if (ttob)
    {
        if (i >= curadd) 
	{
	    return(-1);
	}
    }
    else
    {
	if (i <= curadd)
	return(-1);
    }
    return(0);
}

compare_video_curadd_w(p_me, curadd)
XV_struct* p_me;
int curadd;
{
    int i;
    int ttob,factor,odd;

    PV_RSDW(p_me,ttob,WSqzY.b.ttob);
    PV_RSDW(p_me,factor,WSqzY.b.factor);

    PV_RREG(p_me,i,WCurAdd.l);
    PV_RREG(p_me,odd,IntStat.b.wodd);

    if ((factor > 0x7ff) && (~(odd & 1)))	/* 1 <= squeeze_factor < 2 */
	return(0);	
    i &= 0x3ffff;
    curadd &= 0x3ffff;
    if (ttob)
    {
        if (i >= curadd) 
	    return(-1);
    }
    else
    {
	if (i <= curadd)
	return(-1);
    }
    return(0);
}

plxv_calc_squeeze(p_me, a,b)
    XV_struct* p_me;
int a,b;
{
    int i,j,k,l;
    if (a<0) a = -a;
    if (b<0) b = -b;
    if (b>a) 
    {
	printf("can only squeeze video !!\n");
	return(-1);
    }
    i = ((b<<12) / a) -1 ;
    if ( i & ~(0xfff) )
    {
	printf("weird error\n");
	return(-1);
    }
    return(i);
}


/**********************    CROSS POINT SWITCH STUFF  ******************/
plxv_xpoint_v(p_me, sel,clk_polarity)
    XV_struct* p_me;
int sel,clk_polarity;
{
    int bits;
    switch(sel)
    {
	case INPUT_A:
		p_me->format_v_ptr = &(p_me->plxv_io_format[PORT_A]);
		bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case INPUT_B:
		p_me->format_v_ptr = &(p_me->plxv_io_format[PORT_B]);
		bits = SEL_DATA_INPUT_B | SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	case INPUT_C:
		p_me->format_v_ptr = &(p_me->plxv_io_format[PORT_C]);
		bits = SEL_DATA_INPUT_C | SEL_CTL_INPUT_C | SEL_CLK_INPUT_C;
		break;
	case INPUT_D:
		p_me->format_v_ptr = &(p_me->plxv_io_format[PORT_D]);
/* squash */
        switch( p_me->main.board_code )
		{
		  case SBUS_6:
			break;
		  case SBUS_4:
		  case EISA_BUS_1_135:
		  case EISA_BUS_1_108:
		  case EISA_BUS_1_84:
		  case EISA_BUS_1_64:
			  bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
			  break;
		  default:
		      bits = SEL_DATA_INPUT_D | SEL_CTL_INPUT_D | SEL_CLK_INPUT_D;
			  break;
		}
		break;
	case OUTPUT_A:
	case OUTPUT_B:
	case OUTPUT_LOOPBACK_A:
	case OUTPUT_LOOPBACK_B:
		printf("error - can't output from V channel\n");
		bits = 0;
		break;
	case INPUT_LOOPBACK_A:
		p_me->format_v_ptr = &(p_me->plxv_io_format[LOOPBACK]);
		bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case INPUT_LOOPBACK_B:
		p_me->format_v_ptr = &(p_me->plxv_io_format[LOOPBACK]);
		bits = SEL_DATA_INPUT_B | SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	default:
		printf("plxv_xpoint_v: invalid channel select: %d\n",sel);
    }
    if (clk_polarity) bits |= SEL_CLK_HIGH;
    p_me->xv_wreg->VFormat.l = bits;
	Cache_Flush;
}

plxv_xpoint_w(p_me, sel,clk_polarity)
    XV_struct* p_me;
int sel,clk_polarity;
{
    int bits;
    switch(sel)
    {
	case INPUT_A:
		p_me->format_w_ptr = &(p_me->plxv_io_format[PORT_A]);
	    bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case INPUT_B:
		p_me->format_w_ptr = &(p_me->plxv_io_format[PORT_B]);
		bits = SEL_DATA_INPUT_B | SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	case INPUT_C:
		p_me->format_w_ptr = &(p_me->plxv_io_format[PORT_C]);
		bits = SEL_DATA_INPUT_C | SEL_CTL_INPUT_C | SEL_CLK_INPUT_C;
		break;
	case INPUT_D:
		p_me->format_w_ptr = &(p_me->plxv_io_format[PORT_D]);
/* squash */
        switch( p_me->main.board_code )
		{
		  case SBUS_4:
		  case EISA_BUS_1_135:
		  case EISA_BUS_1_108:
		  case EISA_BUS_1_84:
		  case EISA_BUS_1_64:
		    bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		    break;
		  default:
		    bits = SEL_DATA_INPUT_D | SEL_CTL_INPUT_D | SEL_CLK_INPUT_D;
			break;
		}
		break;
	case OUTPUT_A:
	    p_me->format_w_ptr = &(p_me->plxv_io_format[PORT_A]);
	    bits = SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case OUTPUT_B:
		p_me->format_w_ptr = &(p_me->plxv_io_format[PORT_B]);
		bits =			  SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	case OUTPUT_C:
		p_me->format_w_ptr = &(p_me->plxv_io_format[PORT_C]);
		bits = 			  SEL_CTL_INPUT_C | SEL_CLK_INPUT_C;
		break;
	case OUTPUT_LOOPBACK_A:
		p_me->format_w_ptr = &(p_me->plxv_io_format[LOOPBACK]);
		bits =			  SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case INPUT_LOOPBACK_A:
		p_me->format_w_ptr = &(p_me->plxv_io_format[LOOPBACK]);
		bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case OUTPUT_LOOPBACK_B:
		p_me->format_w_ptr = &(p_me->plxv_io_format[LOOPBACK]);
		bits =			  SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	case INPUT_LOOPBACK_B:
		p_me->format_w_ptr = &(p_me->plxv_io_format[LOOPBACK]);
		bits = SEL_DATA_INPUT_B | SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	default:
		printf("plxv_xpoint_w: invalid channel select: %d\n",sel);
    }
    if (clk_polarity) bits |= SEL_CLK_HIGH;
    PV_WREG(p_me,WFormat.l,bits);
}

/* numbers for config val should be created by oring bit field constant
   found in plxv_xpoint.h */
plxv_xpoint_a(p_me, config_val)
    XV_struct* p_me;
int config_val;
{
    p_me->xv_wreg->AFormat.l = config_val;	
	Cache_Flush;
}

plxv_xpoint_b(p_me, config_val)
    XV_struct* p_me;
int config_val;
{
    p_me->xv_wreg->BFormat.l = config_val;	
	Cache_Flush;
}

plxv_xpoint_c(p_me, config_val)
    XV_struct* p_me;
int config_val;
{
    p_me->xv_wreg->CFormat.l = config_val;	
	Cache_Flush;
}

plxv_xpoint_d(p_me, config_val)
    XV_struct* p_me;
int config_val;
{
    p_me->xv_wreg->DFormat.l = config_val;
	Cache_Flush;
}

plxv_init_attr(p_me)
    XV_struct* p_me;
{
    int i,j;
    /* 2-bit values of attr as interpreted by the option card:
	0 -- pseudo
	1 -- 24-bit true
	2 -- overlay color 1 (cursor 1)
	3 -- overlay color 2 (cursor 2)
    */

    PV_WREG(p_me,WAttrL.b.value0,0);		
    PV_WREG(p_me,WAttrL.b.value1,1);	
    PV_WREG(p_me,WAttrL.b.value2,1);
    PV_WREG(p_me,WAttrL.b.value3,1);

    PV_WREG(p_me,WAttrL.b.value4,0);
    PV_WREG(p_me,WAttrL.b.value5,1);
    PV_WREG(p_me,WAttrL.b.value6,1);
    PV_WREG(p_me,WAttrL.b.value7,1);

    PV_WREG(p_me,WAttrH.b.value8,2);
    PV_WREG(p_me,WAttrH.b.value9,2);
    PV_WREG(p_me,WAttrH.b.value10,2);
    PV_WREG(p_me,WAttrH.b.value11,2);

    PV_WREG(p_me,WAttrH.b.value12,3);
    PV_WREG(p_me,WAttrH.b.value13,3);
    PV_WREG(p_me,WAttrH.b.value14,3);
    PV_WREG(p_me,WAttrH.b.value15,3);

    PV_WREG(p_me,Attr.b.attr0,0);
}
#endif /*NOT DRIVER*/
