#include <hw_context.h>
#include <c3.h>
#include <c3blank.h>

extern C3_WREGS	*c3_wreg;
extern C3_RREGS	*c3_rreg;

int C3HBlank= C3HBLANK;
int C3HSync=  C3HSYNC;
int C3VBlank= C3VBLANK;	
int C3VSync=  C3VSYNC;	

SetC3Blanking(p_me, hblank,hsync,vblank,vsync) 
	XV_struct* p_me;
{
        C3HBlank= hblank;
        C3HSync=  hsync;
        C3VBlank= vblank;
        C3VSync=  vsync;
}

#undef DELAY
#define DELAY(a) 

SetC3GetImageTiming(p_me, width,height,interlaced) 
	XV_struct* p_me;
{
	C3_WREG(p_me,HPeriod,  width + C3HBlank  -1);
	DELAY(DELAY10);
	C3_WREG(p_me,HSync,    C3HSync);
	DELAY(DELAY10);
	C3_WREG(p_me,HDelay,   C3HBlank/2);
	DELAY(DELAY10);
	C3_WREG(p_me,HActive,  2 * (width/8) -1);
	DELAY(DELAY10);
	C3_WREG(p_me,VSync,    C3VSync);
	DELAY(DELAY10);
	C3_WREG(p_me,VDelay,   C3VBlank/2);	
	DELAY(DELAY10);
	C3_WREG(p_me,VActive,  (height/8/(interlaced ? 2 : 1)) );
	DELAY(DELAY10);
	C3_WREG(p_me,VPeriod,  height/(interlaced ? 2 : 1) + C3VBlank  -1);
	DELAY(DELAY10);
	C3_WREG(p_me,HControl, 0);
	DELAY(DELAY10);
	C3_WREG(p_me,VControl, 0);
}

SetC3PutImageTiming(p_me, width,height)
	XV_struct* p_me;
{
	C3_WREG(p_me,HPeriod,  width + C3HBlank  -1);
	DELAY(DELAY10);
	C3_WREG(p_me,HSync,    C3HSync);
	DELAY(DELAY10);
	C3_WREG(p_me,HDelay,   C3HBlank/2);
	DELAY(DELAY10);
	C3_WREG(p_me,HActive,  2 * (width/8) -1);
	DELAY(DELAY10);
	C3_WREG(p_me,VSync,    C3VSync);
	DELAY(DELAY10);
	C3_WREG(p_me,VDelay,   C3VBlank/2 - 9); 
	DELAY(DELAY10);
	C3_WREG(p_me,VPeriod,  height + C3VBlank  -1 );
	DELAY(DELAY10);
	C3_WREG(p_me,VActive,  (height/8));
	DELAY(DELAY10);
	C3_WREG(p_me,HControl, ~0);
	DELAY(DELAY10);
	C3_WREG(p_me,VControl, ~0);
}

