/*
 *	@(#)cfbreg.h	1.1.1.3	(ULTRIX)	1/26/90
 */
/************************************************************************
 *									*
 *			Copyright (c) 1986 by				*
 *		Digital Equipment Corporation, Maynard, MA		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any	other copies thereof may not be provided or	*
 *   otherwise made available to any other person.  No title to and	*
 *   ownership of the software is hereby transferred.			*
 *									*
 *   This software is  derived  from  software  received  from  the	*
 *   University	of   California,   Berkeley,   and   from   Bell	*
 *   Laboratories.  Use, duplication, or disclosure is  subject  to	*
 *   restrictions  under  license  agreements  with  University  of	*
 *   California and with AT&T.						*
 *									*
 *   The information in this software is subject to change  without	*
 *   notice  and should not be construed as a commitment by Digital	*
 *   Equipment Corporation.						*
 *									*
 *   Digital assumes no responsibility for the use  or	reliability	*
 *   of its software on equipment which is not supplied by Digital.	*
 *									*
 ************************************************************************/

/***********************************************************************
 *
 * Modification History:
 *
 * 27-Sep-89  -- Randall Brown
 *	Created file. Derived from pmreg.h
 *
 **********************************************************************/

/*
 * VAXstar Monochrome definitions.
 */

#define	SELF_TEST	'T'
#define	INCREMENTAL	'R'
#define	PROMPT		'D'

#define	MOUSE_ID	0x2
#define TABLET_ID	0x4

#define START_FRAME	0x80		/* start of report frame bit */
#define X_SIGN		0x10		/* sign bit for X */
#define Y_SIGN		0x08		/* sign bit for Y */

#define	CFB_XOFFSET		219
#define	CFB_YOFFSET		 34

#define CFB_SCREEN_OFF	       0x1

#define OFF_SCREEN_X	2048
#define OFF_SCREEN_Y	2048

#define	UPDATE_POS	0x01

/*
 * VAXstar interrupt controller register bits
 *
 */

#define SINT_VF		010

/*
 * Line Prameter Register bits
 *
 */

#define	SER_KBD      000000
#define	SER_POINTER  000001
#define	SER_COMLINE  000002
#define	SER_PRINTER  000003
#define	SER_CHARW    000030
#define	SER_STOP     000040
#define	SER_PARENB   000100
#define	SER_ODDPAR   000200
#define	SER_SPEED    006000
#define	SER_RXENAB   010000


/*
 * Mouse definitions
 *
 */

#define MOTION_BUFFER_SIZE 100
#define	SELF_TEST	'T'

#define EVENT_T_LEFT_BUTTON	0x01
#define EVENT_T_FRONT_BUTTON	0x02
#define EVENT_T_RIGHT_BUTTON	0x03
#define EVENT_T_BACK_BUTTON	0x04

/* puck buttons */

#define T_LEFT_BUTTON		0x02
#define T_FRONT_BUTTON		0x04
#define T_RIGHT_BUTTON		0x08
#define T_BACK_BUTTON		0x10

/*
 * Lk201 keyboard 
 */

#define LK_DOWN 	0x80
#define LED_ALL 	0x8f
#define LK_KDOWN_ERROR	0x3d		/* key down on powerup error */
#define LK_OUTPUT_ERROR	0xb5		/* keystrokes lost during inhibit */
#define LK_LOWEST	0x56		/* lowest significant keycode */
#define LK_DIV6_START	0xad		/* start of div 6 */
#define LK_DIV5_END	0xb2		/* end of div 5 */

/*
 * Keycodes for special keys and functions
 */

#define SHIFT	0xae
#define LOCK	0xb0
#define REPEAT	0xb4
#define CNTRL	0xaf
#define ALLUP	0xb3
#define	HOLD	0x56

#define	CONSOLEMAJOR	0
#define CONS_DEV	0x01
#define GRAPHIC_DEV	0x02

struct bt459 {
    volatile char addr_LOW;
    char pad1[3];
    volatile char addr_HIGH;
    char pad2[3];
    volatile char bt_REG;
    char pad3[3];
    volatile char color_MAP;
    char pad4[3];
};

struct cfb_keyboard {
    int shift;
    int cntrl;
    int lock;
    int hold;
    char last;
};

#define addr_low	bt459->addr_LOW
#define addr_high	bt459->addr_HIGH
#define bt_reg		bt459->bt_REG
#define color_map	bt459->color_MAP

#ifdef notdef
struct cfb_softc {
    char *framebuffer;/* base pointer to framebuffer 	*/
    volatile struct bt459 *bt459;	/* base pointer of bt459 regs  	*/
    cfbEventQueue qe;		/* event & motion queues	*/
    char     *bitmap;	/* user base pointer to cfb	*/
    short	mswitches;		/* current value of mouse buttons */
    cfbCursor tablet;		/* current tablet position	*/
    short	tswitches;		/* current tablet buttons NI!	*/
    cfbCursor cursor;		/* current cursor position	*/
    u_char	bgRgb[3];		/* background cursor color	*/
    u_char	fgRgb[3];		/* foreground cursor color 	*/
    short	row;			/* screen row		       	*/
    short 	col;			/* screen col			*/
    short	max_row;		/* max character row		*/
    short	max_col;		/* max character col		*/
    short	max_x;			/* max x position		*/
    short	max_y;			/* max y position		*/
    short	min_cur_x;		/* min cursor x position	*/
    short	min_cur_y;		/* min cursor y position	*/
    short	max_cur_x;		/* max cursor x position 	*/
    short	max_cur_y;		/* max cursor y position	*/
    int		version;		/* version of driver		*/
    cfbCursor 	mouse;			/* atomic read/write		*/
    cfbBox	mbox;			/* atomic read/write		*/
    short	mthreshold;		/* mouse motion parameter	*/
    short	mscale;			/* mouse scale factor (if 	*/
					/* negative, then do square).	*/
};
#endif notdef

#define ADDR_LOW_MASK		0x00ff
#define ADDR_HIGH_MASK		0xff00

#define BT459_OFFSET		0x200000
#define IREQ_OFFSET		0x300000

#define COLOR_MAP_BASE		0

#define	OVERLAY_COLOR_BASE	0x0100
#define CURSOR_COLOR_1		0x0181
#define	CURSOR_COLOR_2		0x0182
#define	CURSOR_COLOR_3		0x0183
#define	ID_REG			0x0200
#define CMD_REG_0		0x0201
#define	CMD_REG_1		0x0202
#define CMD_REG_2		0x0203
#define PIXEL_READ_MASK		0x0204
#define PIXEL_BLINK_MASK	0x0206
#define OVERLAY_READ_MASK	0x0208
#define OVERLAY_BLINK_MASK	0x0209
#define	INTERLEAVE_REG		0x020a
#define	TEST_REG		0x020b
#define	RED_SIGNATURE		0x020c
#define GREEN_SIGNATURE		0x020d
#define BLUE_SIGNATURE		0x020e
#define CURSOR_CMD_REG		0x0300
#define CURSOR_X_LOW		0x0301
#define CURSOR_X_HIGH		0x0302
#define CURSOR_Y_LOW		0x0303
#define CURSOR_Y_HIGH		0x0304
#define WINDOW_X_LOW		0x0305
#define WINDOW_X_HIGH		0x0306
#define WINDOW_Y_LOW		0x0307
#define WINDOW_Y_HIGH		0x0308
#define WINDOW_WIDTH_LOW	0x0309
#define WINDOW_WIDTH_HIGH	0x030a
#define	WINDOW_HEIGHT_LOW	0x030b
#define WINDOW_HEIGHT_HIGH 	0x030c
#define CURSOR_RAM_BASE		0x0400

#define TOY ((time.tv_sec * 1000) + (time.tv_usec / 1000))
    
    
#define	PIXELS_PER_ROW		15 * 1024
#define PIXELS_PER_COL		8
