/*
** File:
**
**   event_record.h -- Macros to record events in device drivers.
**
** Author:
**
**   Andy Goodrich (Parallax)
**
** Revisions:
**
**   07.26.95 Andy Goodrich
**     - Initial Definition.
**
*/

#ifndef event_record_h_INCLUDED
#define event_record_h_INCLUDED

#ifndef Event_Entry_DEFINED
typedef int Event_Entry;
#endif

typedef struct _Event_Queue {
	int		    i_read;
	int		    i_write;
	int		    wrap_mask;
	Event_Entry queue[1024];
} Event_Queue;

#define Event_Add(q, v) { q.queue[q.i_write & q.wrap_mask] = v; q.i_write++; }

#define Event_Empty( q ) {q.i_read = q.i_write = 0;}

#define Event_Remove(q, v) { v = q.queue[q.i_read & q.wrap_mask]; q.i_read++; };

#define Event_Is_Empty( q ) ( q.i_read >= q.i_write )

#define Event_Storage( q ) static Event_Queue q = {0, 0, 1024-1,{0}};



#endif  /* event_record_h_INCLUDED */
