/* $XConsortium: dixfontstr.h,v 1.6 89/03/11 15:20:13 rws Exp $ */
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef R4_DIXFONTSTRUCT_H
#define R4_DIXFONTSTRUCT_H

#include "R4dixfont.h"
#include "R4font.h"
#include "misc.h"

typedef struct _R4DIXFontProp {
    ATOM	name;
    INT32	value;	/* assumes ATOM is not larger than INT32 */
} R4DIXFontProp;

/*
 * FONT is created at font load time; it is not part of the
 * font file format
 */
typedef struct _R4Font {
    R4FontInfoPtr	pFI;
    R4DIXFontProp	*pFP;
    R4CharInfoPtr	pCI;			/* bitmap metrics and offset */
    char	*pGlyphs;
    pointer	osPrivate;
    int		fileType;		/* tag for OS layer */
    int		refcnt;			/* free storage when this goes to 0 */
    pointer	devPriv[MAXSCREENS];	/* information private to screen */
    R4CharInfoPtr	pInkCI;		/* ink metrics */
    R4CharInfoPtr	pInkMin;	/* ink metrics */
    R4CharInfoPtr	pInkMax;	/* ink metrics */
} R4FontRec;

typedef struct _Shadow {
    Bool 	allocated;
    R4FontRec	*pFont;
} ShadowRec;

typedef struct _Shadow *ShadowPtr;


#endif /* R4_DIXFONTSTRUCT_H */
