#ifndef CLOSESTR_H
#define CLOSESTR_H

#define	NEED_REPLIES
#include "Xproto.h"
#include "closure.h"
#include "dix.h"
#include "misc.h"
#ifdef CACHE_GLYPHS
#include "gcstruct.h"
#endif /* CACHE_GLYPHS */

/* closure structures */
typedef struct _OFclosure {
    ClientPtr   client;
    short       current_fpe;
    short       num_fpes;
    FontPathElementPtr *fpe_list;
    Mask        flags;
    Bool        slept;

/* XXX -- get these from request buffer instead? */
    char       *origFontName;
    int		origFontNameLen;
    XID         fontid;
    char       *fontname;
    int         fnamelen;
#if defined(VALUE_ADDED)
    pointer	arena;
    int		pass;
#endif /* defined(VALUE_ADDED) */
}           OFclosureRec;

typedef struct _LFclosure {
    ClientPtr		client;
    short		current_fpe;
    short		num_fpes;
    FontPathElementPtr	*fpe_list;
    FontNamesPtr	names;
    char		*pattern;
    int			max_names;
    int			patlen;
    Bool		slept;
#if defined(VALUE_ADDED)
    pointer	arena;
#endif /* defined(VALUE_ADDED) */
}           LFclosureRec;

typedef struct _LFWIstate {
    char	*pattern;
    int		patlen;
    int		current_fpe;
    int		max_names;
    Bool	list_started;
    pointer	private;
} LFWIstateRec, *LFWIstatePtr;

typedef struct _LFWIclosure {
    ClientPtr		client;
    int			num_fpes;
    FontPathElementPtr	*fpe_list;
    xListFontsWithInfoReply *reply;
    int			length;
    LFWIstateRec	current;
    LFWIstateRec	saved;
    int			savedNumFonts;
    Bool		haveSaved;
    Bool		slept;
    char		*savedName;
#if defined(VALUE_ADDED)
    pointer		arena;
#endif /* defined(VALUE_ADDED) */
} LFWIclosureRec;

#ifdef CACHE_GLYPHS
typedef struct _PTclosure {
    ClientPtr		client;
    DrawablePtr		pDraw;
    GC			*pGC;
    unsigned char	*pElt;
    unsigned char	*endReq;
    unsigned char	*data;
    int			xorg;
    int			yorg;
    CARD8		reqType;
    int			(* polyText)();
    int			itemSize;
    XID			did;
    int			err;
    Bool		slept;
#if defined(VALUE_ADDED)
    pointer		arena;
#endif /* defined(VALUE_ADDED) */
} PTclosureRec;

typedef struct _ITclosure {
    ClientPtr		client;
    DrawablePtr		pDraw;
    GC			*pGC;
    BYTE		nChars;
    unsigned char	*data;
    int			xorg;
    int			yorg;
    CARD8		reqType;
    void		(* imageText)();
    int			itemSize;
    XID			did;
    Bool		slept;
#if defined(VALUE_ADDED)
    pointer		arena;
#endif /* defined(VALUE_ADDED) */
} ITclosureRec;
#endif /* CACHE_GLYPHS */
#endif				/* CLOSESTR_H */
