/*
** File: 
**
**   xvddx.h --- Xv video extension device dependent layer 
**               interface. This defines a standard object for 
**               accessing device-dependent functions. The layer
**               may be replaced with a vendor's specific 
**               implementation by utilizing a different xvddx.c and
**               xvddx.h.
**            
**
** Author: 
**
**   Andy Goodrich (RasterOps)
**
** Revisions:
**
**   08.08.92 Andy Goodrich
**     - Initial definition.
**
** $Log:   /plxhp/dave/pvcsrc/xv/include/archives/xvddx.h_v  $
 * 
 *    Rev 1.1   09 Sep 1996 10:39:08   dave
 * Initial revision
** Revision 1.1  1995/05/02 11:55:48  dist
** Initial revision
**
**
** Notes:
**   (1) Tab stops every four characters.
*/

#ifndef xvddx_INCLUDED
#define xvddx_INCLUDED 

#ifdef GLOBAL
#define EXTERNAL
#define INIT(i) = {i}
#else /* GLOBAL */
#define EXTERNAL extern
#define INIT(i)
#endif /* GLOBAL */

/*----------------------------------------------------------------------------*
 |  Private Data Structures For XvAdaptorRec, and XvPortRec:
 *----------------------------------------------------------------------------*/
typedef struct _XvddPortRec {	  /* Pointed to by XvPortRec.devPrivate. */
  int           brightness;
  int           contrast;
  unsigned int  dh;
  unsigned int  dw;
  int           dx;
  int           dy;
  Bool			flip_horizontal;
  Bool			flip_vertical;
  Bool			invert_fields;
  Bool          gray;
  int           hue;
  pointer       phw;	
  int           saturation;
  unsigned int  vh;
  RegionRec		visible_area;	/* Area of screen with visible video. */
  unsigned int  vw;
  int           vx;
  int           vy;
} XvddPortRec, *XvddPortPtr;


#endif /* xvddx_h_INCLUDED */
