/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 */
/*
** File:
**
**  encodings_PGIpv700.h: Encodings for HP platform version of Parallax
**                        PowerVideo product.
**
** Author:
**
**   Andy Goodrich (Parallax)
**
** Revisions:
**
** $Log:   /export/home/dist1/source/xv/server/ddx/PGIpv/archives/encodings_PGIpv700.h_v  $
 * 
 *    Rev 1.5   19 Sep 1996 08:24:56   dave
 * fixed encodings for option 1
 * 
 *    Rev 1.4   11 Sep 1996 13:47:28   dave
 * rate for ntsc was right so put back,
 * change rate from 25 to 50 for pal
 * 
 *    Rev 1.3   11 Sep 1996 07:23:22   dave
 * fixed ntsc and pal frequencies
 * 
 *    Rev 1.2   09 Sep 1996 10:40:12   dave
 * deleted secam output encoding
** Revision 1.2  1996/07/26 10:32:27  dave
** deleted secam output encoding
**
 * Revision 1.1  95/05/25  17:02:49  17:02:49  dist (Software Distribution Account)
 * Initial revision
 * 
*/

enum {						/* Zoom encoding options. */
	OPT_0_ZOOM = OPT_2+1,
	OPT_1_ZOOM = OPT_2+2,
	OPT_2_ZOOM = OPT_2+3,
};


/*
 *  ENCODING AND SIGNAL INFORMATION:
 */
static XvEncodingRec PGIpvBaseEncodings[] =
{
    {XV_COMPOSITE | XV_NTSC, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_NTSC | 1, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL | 1, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM | 1, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_NTSC | 2, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL | 2, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM | 2, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},
};
#define nPGIpvBaseEncodings \
        (sizeof(PGIpvBaseEncodings)/sizeof(PGIpvBaseEncodings[0]))

static XvEncodingRec PGIpvZoom2BaseEncodings[] =
{
    {XV_COMPOSITE | XV_NTSC, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_NTSC | 1, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL | 1, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM | 1, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_NTSC | 2, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL | 2, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM | 2, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
};
#define nPGIpvZoom2BaseEncodings \
       (sizeof(PGIpvZoom2BaseEncodings)/sizeof(PGIpvZoom2BaseEncodings[0]))

#define DMSD2 (1 << 4)

static XvEncodingRec PGIpvOpt1Encodings[] =
{
    {XV_COMPOSITE | XV_NTSC, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_COMPOSITE | XV_NTSC | 1, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL | 1, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM | 1, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_COMPOSITE | XV_NTSC | 2, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL | 2, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM | 2, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_COMPOSITE | XV_NTSC | DMSD2, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL | DMSD2, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM | DMSD2, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_COMPOSITE | XV_NTSC | DMSD2 | 1, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL | DMSD2 | 1, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM | DMSD2 | 1, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_YC | XV_NTSC | DMSD2, (ScreenPtr)NULL,
       "ntsc-svideo", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_YC | XV_PAL | DMSD2, (ScreenPtr)NULL,
       "pal-svideo", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_YC | XV_SECAM | DMSD2, (ScreenPtr)NULL,
       "secam-svideo", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_YC | XV_NTSC | DMSD2 | 1, (ScreenPtr)NULL,
       "ntsc-svideo", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_YC | XV_PAL | DMSD2 | 1, (ScreenPtr)NULL,
       "pal-svideo", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_YC | XV_SECAM | DMSD2 | 1, (ScreenPtr)NULL,
       "secam-svideo", -10, 778, -10, 582, 768, 576, 50, 1},
};
#define nPGIpvOpt1Encodings \
        (sizeof(PGIpvOpt1Encodings)/sizeof(PGIpvOpt1Encodings[0]))

static XvEncodingRec PGIpvZoom2Opt1Encodings[] =
{
    {XV_COMPOSITE | XV_NTSC, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_COMPOSITE | XV_NTSC | 1, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL | 1, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM | 1, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_COMPOSITE | XV_NTSC | 2, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL | 2, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM | 2, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_COMPOSITE | XV_NTSC | DMSD2, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL | DMSD2, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM | DMSD2, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_COMPOSITE | XV_NTSC | DMSD2 | 1, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL | DMSD2 | 1, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM | DMSD2 | 1, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_YC | XV_NTSC | DMSD2, (ScreenPtr)NULL,
       "ntsc-svideo", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_YC | XV_PAL | DMSD2, (ScreenPtr)NULL,
       "pal-svideo", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_YC | XV_SECAM | DMSD2, (ScreenPtr)NULL,
       "secam-svideo", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_YC | XV_NTSC | DMSD2 | 1, (ScreenPtr)NULL,
       "ntsc-svideo", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_YC | XV_PAL | DMSD2 | 1, (ScreenPtr)NULL,
       "pal-svideo", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_YC | XV_SECAM | DMSD2 | 1, (ScreenPtr)NULL,
       "secam-svideo", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
};
#define nPGIpvZoom2Opt1Encodings \
       (sizeof(PGIpvZoom2Opt1Encodings)/sizeof(PGIpvZoom2Opt1Encodings[0]))

static XvEncodingRec PGIpvOpt2Encodings[] =
{
    {XV_COMPOSITE | XV_NTSC | DMSD2, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL | DMSD2, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM | DMSD2, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_COMPOSITE | XV_NTSC | DMSD2 | 1, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_COMPOSITE | XV_PAL | DMSD2 | 1, (ScreenPtr)NULL,
       "pal-composite", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_COMPOSITE | XV_SECAM | DMSD2 | 1, (ScreenPtr)NULL,
       "secam-composite", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_YC | XV_NTSC | DMSD2, (ScreenPtr)NULL,
       "ntsc-svideo", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_YC | XV_PAL | DMSD2, (ScreenPtr)NULL,
       "pal-svideo", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_YC | XV_SECAM | DMSD2, (ScreenPtr)NULL,
       "secam-svideo", -10, 778, -10, 582, 768, 576, 50, 1},

    {XV_YC | XV_NTSC | DMSD2 | 1, (ScreenPtr)NULL,
       "ntsc-svideo", -10, 650, -10, 490, 640, 480, 5994, 100},
    {XV_YC | XV_PAL | DMSD2 | 1, (ScreenPtr)NULL,
       "pal-svideo", -10, 778, -10, 582, 768, 576, 50, 1},
    {XV_YC | XV_SECAM | DMSD2 | 1, (ScreenPtr)NULL,
       "secam-svideo", -10, 778, -10, 582, 768, 576, 50, 1},
};

#define nPGIpvOpt2Encodings \
        (sizeof(PGIpvOpt2Encodings)/sizeof(PGIpvOpt2Encodings[0]))


static XvEncodingRec PGIpvZoom2Opt2Encodings[] =
{
    {XV_COMPOSITE | XV_NTSC | DMSD2, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL | DMSD2, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM | DMSD2, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_COMPOSITE | XV_NTSC | DMSD2 | 1, (ScreenPtr)NULL,
       "ntsc-composite", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_COMPOSITE | XV_PAL | DMSD2 | 1, (ScreenPtr)NULL,
       "pal-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_COMPOSITE | XV_SECAM | DMSD2 | 1, (ScreenPtr)NULL,
       "secam-composite", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_YC | XV_NTSC | DMSD2, (ScreenPtr)NULL,
       "ntsc-svideo", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_YC | XV_PAL | DMSD2, (ScreenPtr)NULL,
       "pal-svideo", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_YC | XV_SECAM | DMSD2, (ScreenPtr)NULL,
       "secam-svideo", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},

    {XV_YC | XV_NTSC | DMSD2 | 1, (ScreenPtr)NULL,
       "ntsc-svideo", -10, 650*2, -10, 490*2, 640*2, 480*2, 5994, 100},
    {XV_YC | XV_PAL | DMSD2 | 1, (ScreenPtr)NULL,
       "pal-svideo", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
    {XV_YC | XV_SECAM | DMSD2 | 1, (ScreenPtr)NULL,
       "secam-svideo", -10, 778*2, -10, 582*2, 768*2, 576*2, 50, 1},
};

#define nPGIpvZoom2Opt2Encodings \
       (sizeof(PGIpvZoom2Opt2Encodings)/sizeof(PGIpvZoom2Opt2Encodings[0]))

/*
 *  RASTEROPS COMPATIBILITY STUFF:
 */
#define PIP_NTSC       (1L<<0)
#define PIP_PAL        (1L<<1)
#define PIP_SECAM      (1L<<2)
#define PIP_COMPOSITE  (1L<<3)
#define PIP_SVIDEO     (1L<<4)
#define PIP_RGB        (1L<<5)
#define PIP_COMPOSITE2 (1L<<6)
#define PIP_GRAY       (1L<<7)

static struct _ETT {
	int		new;	/* New ddx layer style encoding id. */
	int		rops;	/* RasterOps old style encoding id. */
} translate_encoding[] = {
    {XV_COMPOSITE  | XV_NTSC,      PIP_COMPOSITE  | PIP_NTSC},
    {XV_COMPOSITE  | XV_PAL,       PIP_COMPOSITE  | PIP_PAL},
    {XV_COMPOSITE  | XV_SECAM,     PIP_COMPOSITE  | PIP_SECAM},
    {XV_COMPOSITE  | XV_NTSC | 1,  PIP_COMPOSITE2 | PIP_NTSC},
    {XV_COMPOSITE  | XV_PAL | 1,   PIP_COMPOSITE2 | PIP_PAL},
    {XV_COMPOSITE  | XV_SECAM | 1, PIP_COMPOSITE2 | PIP_SECAM},
    {XV_YC | DMSD2 | XV_NTSC,      PIP_SVIDEO     | PIP_NTSC},
    {XV_YC | DMSD2 | XV_PAL,       PIP_SVIDEO     | PIP_PAL},
    {XV_YC | DMSD2 | XV_SECAM,     PIP_SVIDEO     | PIP_SECAM},
};
static int nTranslates = sizeof(translate_encoding) / sizeof(struct _ETT);
static int RasterOps = 0;

/*  END OF RASTEROPS COMPATIBILITY STUFF. */

enum {
    NTSC_BLANK   = 43,
    NTSC_BLANK2  = 2*43,
    NTSC_HEIGHT  = 525,
    NTSC_HEIGHT2 = 2*525,
    NTSC_RATE    = 60,
    NTSC_WIDTH   = 640,
    NTSC_WIDTH2  = 640*2,
    PAL_BLANK    = 50,
    PAL_BLANK2   = 2*50,
    PAL_HEIGHT   = 625,
    PAL_HEIGHT2  = 625*2,
    PAL_RATE     = 50,
    PAL_WIDTH    = 768,
    PAL_WIDTH2   = 768*2,

	PLX_NTSC     = 2,
	PLX_PAL      = 4,
	PLX_SECAM    = 5,

	PLX_COMP     = 2,
    PLX_YC       = 3,
    PLX_YUV      = 4,
    PLX_RGB      = 5,

	PLX_INPUT_0  = 1,
	PLX_INPUT_1  = 2,
	PLX_OUTPUT_0 = 32,
};

static XvplxSignalRec PGIpvBaseSignals[] =
{   /* Encoding Id:               channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
    {XV_COMPOSITE | XV_SECAM | 0, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 0,   1},

    {XV_COMPOSITE | XV_NTSC | 1,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 1,   1},
    {XV_COMPOSITE | XV_PAL | 1,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_SECAM | 1, PLX_INPUT_0,   0,
        PLX_SECAM, PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_NTSC | 2,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 2,   1},
    {XV_COMPOSITE | XV_PAL | 2,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  2,   1},
    {XV_COMPOSITE | XV_SECAM | 2, PLX_INPUT_0,   0,
        PLX_SECAM, PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  2,   1},
};
#define lPGIpvBaseSignals sizeof(PGIpvBaseSignals)
 
static XvplxSignalRec PGIpvZoom2BaseSignals[] =
{   /* Encoding Id:               channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  0,   1},
    {XV_COMPOSITE | XV_SECAM | 0, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE, 0,   1},

    {XV_COMPOSITE | XV_NTSC | 1,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 1,   1},
    {XV_COMPOSITE | XV_PAL | 1,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_SECAM | 1, PLX_INPUT_0,   0,
        PLX_SECAM, PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_NTSC | 2,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 2,   1},
    {XV_COMPOSITE | XV_PAL | 2,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  2,   1},
    {XV_COMPOSITE | XV_SECAM | 2, PLX_INPUT_0,   0,
        PLX_SECAM, PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  2,   1},
};
#define lPGIpvZoom2BaseSignals sizeof(PGIpvZoom2BaseSignals)
 
static XvplxSignalRec PGIpvOpt1Signals[] =
{   /* DMSD # 1 */ 
	/* Encoding Id:              channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0,  PLX_INPUT_0,   0, 
	    PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
    {XV_COMPOSITE | XV_SECAM | 0, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 0,   1},

    {XV_COMPOSITE | XV_NTSC | 1,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 1,   1},
    {XV_COMPOSITE | XV_PAL | 1,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_SECAM | 1, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 1,   1},

    {XV_COMPOSITE | XV_NTSC | 2,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 2,   1},
    {XV_COMPOSITE | XV_PAL | 2,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  2,   1},
    {XV_COMPOSITE | XV_SECAM | 2, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 2,   1},

    /* DMSD # 2 */ 
	/* Encoding Id:              channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0x10,  PLX_INPUT_1,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0x10,   PLX_INPUT_1,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
    {XV_COMPOSITE | XV_SECAM | 0x10, PLX_INPUT_1,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 0,   1},

    {XV_COMPOSITE | XV_NTSC | 0x11,  PLX_INPUT_1,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 1,   1},
    {XV_COMPOSITE | XV_PAL | 0x11,   PLX_INPUT_1,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_SECAM | 0x11, PLX_INPUT_1,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 1,   1},

    {XV_YC | XV_NTSC | 0x10,         PLX_INPUT_1,   0, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_YC | XV_PAL | 0x10,          PLX_INPUT_1,   0,    
        PLX_PAL,   PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
    {XV_YC | XV_SECAM | 0x10,        PLX_INPUT_1,   0,
        PLX_SECAM, PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},

    {XV_YC | XV_NTSC | 0x11,         PLX_INPUT_1,   0, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 1,   1},
    {XV_YC | XV_PAL | 0x11,          PLX_INPUT_1,   0,    
        PLX_PAL,   PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},
    {XV_YC | XV_SECAM | 0x11,        PLX_INPUT_1,   0,
        PLX_SECAM, PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},

    /* DMSE # 1 */ 
	/* Encoding Id:              channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0x10,  PLX_OUTPUT_0,   1, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0x10,   PLX_OUTPUT_0,   1,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
#if 0
    {XV_COMPOSITE | XV_SECAM | 0x10, PLX_OUTPUT_0,   1,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 0,   1},
#endif
    {XV_YC | XV_NTSC | 0x10,         PLX_OUTPUT_0,   1, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_YC | XV_PAL | 0x10,          PLX_OUTPUT_0,   1,    
        PLX_PAL,   PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
#if 0
    {XV_YC | XV_SECAM | 0x10,        PLX_OUTPUT_0,   1,
        PLX_SECAM, PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
#endif
};
#define lPGIpvOpt1Signals sizeof(PGIpvOpt1Signals)
 

static XvplxSignalRec PGIpvZoom2Opt1Signals[] =
{   /* DMSD # 1 */ 
	/* Encoding Id:              channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0,  PLX_INPUT_0,   0, 
	    PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  0,   1},
    {XV_COMPOSITE | XV_SECAM | 0, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE, 0,   1},

    {XV_COMPOSITE | XV_NTSC | 1,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 1,   1},
    {XV_COMPOSITE | XV_PAL | 1,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_SECAM | 1, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE, 1,   1},

    {XV_COMPOSITE | XV_NTSC | 2,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 2,   1},
    {XV_COMPOSITE | XV_PAL | 2,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  2,   1},
    {XV_COMPOSITE | XV_SECAM | 2, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE, 2,   1},

    /* DMSD # 2 */ 
	/* Encoding Id:              channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0x10,  PLX_INPUT_1,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0x10,   PLX_INPUT_1,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  0,   1},
    {XV_COMPOSITE | XV_SECAM | 0x10, PLX_INPUT_1,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE, 0,   1},

    {XV_COMPOSITE | XV_NTSC | 0x11,  PLX_INPUT_1,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 1,   1},
    {XV_COMPOSITE | XV_PAL | 0x11,   PLX_INPUT_1,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_SECAM | 0x11, PLX_INPUT_1,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE, 1,   1},

    {XV_YC | XV_NTSC | 0x10,         PLX_INPUT_1,   0, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 0,   1},
    {XV_YC | XV_PAL | 0x10,          PLX_INPUT_1,   0,    
        PLX_PAL,   PLX_YC, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  0,   1},
    {XV_YC | XV_SECAM | 0x10,        PLX_INPUT_1,   0,
        PLX_SECAM, PLX_YC, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  0,   1},

    {XV_YC | XV_NTSC | 0x11,         PLX_INPUT_1,   0, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 1,   1},
    {XV_YC | XV_PAL | 0x11,          PLX_INPUT_1,   0,    
        PLX_PAL,   PLX_YC, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},
    {XV_YC | XV_SECAM | 0x11,        PLX_INPUT_1,   0,
        PLX_SECAM, PLX_YC, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},

    /* DMSE # 1 */ 
	/* Encoding Id:              channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0x10,  PLX_OUTPUT_0,   1, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0x10,   PLX_OUTPUT_0,   1,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT2,  PAL_BLANK,  PAL_RATE,  0,   1},
#if 0
    {XV_COMPOSITE | XV_SECAM | 0x10, PLX_OUTPUT_0,   1,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 0,   1},
#endif
    {XV_YC | XV_NTSC | 0x10,         PLX_OUTPUT_0,   1, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_YC | XV_PAL | 0x10,          PLX_OUTPUT_0,   1,    
        PLX_PAL,   PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
#if 0
    {XV_YC | XV_SECAM | 0x10,        PLX_OUTPUT_0,   1,
        PLX_SECAM, PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
#endif
};
#define lPGIpvZoom2Opt1Signals sizeof(PGIpvZoom2Opt1Signals)
 

static XvplxSignalRec PGIpvOpt2Signals[] =
{   /* DMSD #2 */
	/* Encoding Id:              channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0x10,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0x10,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
    {XV_COMPOSITE | XV_SECAM | 0x10, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 0,   1},

    {XV_COMPOSITE | XV_NTSC | 0x11,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 1,   1},
    {XV_COMPOSITE | XV_PAL | 0x11,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_SECAM | 0x11, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE, 1,   1},

    {XV_YC | XV_NTSC | 0x10,         PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 0,   1},
    {XV_YC | XV_PAL | 0x10,          PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},
    {XV_YC | XV_SECAM | 0x10,        PLX_INPUT_0,   0,
        PLX_SECAM, PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  0,   1},

    {XV_YC | XV_NTSC | 0x11,         PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE, 1,   1},
    {XV_YC | XV_PAL | 0x11,          PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},
    {XV_YC | XV_SECAM | 0x11,        PLX_INPUT_0,   0,
        PLX_SECAM, PLX_YC, PAL_WIDTH, PAL_HEIGHT,  PAL_BLANK,  PAL_RATE,  1,   1},

};
#define lPGIpvOpt2Signals sizeof(PGIpvOpt2Signals)


static XvplxSignalRec PGIpvZoom2Opt2Signals[] =
{   /* DMSD #2 */
	/* Encoding Id:              channel      type                       */
    /*  standard    format    width     height       blank       rate     num sync */
    /*  --------    ------    -----     ------       -----       ----     --- ---- */
    {XV_COMPOSITE | XV_NTSC | 0x10,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 0,   1},
    {XV_COMPOSITE | XV_PAL | 0x10,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  0,   1},
    {XV_COMPOSITE | XV_SECAM | 0x10, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE, 0,   1},

    {XV_COMPOSITE | XV_NTSC | 0x11,  PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_COMP, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 1,   1},
    {XV_COMPOSITE | XV_PAL | 0x11,   PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},
    {XV_COMPOSITE | XV_SECAM | 0x11, PLX_INPUT_0,   0,
        PLX_SECAM,  PLX_COMP, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE, 1,   1},

    {XV_YC | XV_NTSC | 0x10,         PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 0,   1},
    {XV_YC | XV_PAL | 0x10,          PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_YC, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  0,   1},
    {XV_YC | XV_SECAM | 0x10,        PLX_INPUT_0,   0,
        PLX_SECAM, PLX_YC, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  0,   1},

    {XV_YC | XV_NTSC | 0x11,         PLX_INPUT_0,   0, 
		PLX_NTSC, PLX_YC, NTSC_WIDTH2, NTSC_HEIGHT2, NTSC_BLANK2, NTSC_RATE, 1,   1},
    {XV_YC | XV_PAL | 0x11,          PLX_INPUT_0,   0,    
        PLX_PAL,   PLX_YC, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},
    {XV_YC | XV_SECAM | 0x11,        PLX_INPUT_0,   0,
        PLX_SECAM, PLX_YC, PAL_WIDTH2, PAL_HEIGHT2,  PAL_BLANK2,  PAL_RATE,  1,   1},

};
#define lPGIpvZoom2Opt2Signals sizeof(PGIpvZoom2Opt2Signals)
