/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *
 * 					All Rights Reserved
 *
 *   Permission to use, copy, modify, and distribute this software and its 
 *   documentation for any purpose and without fee is hereby granted, 
 *   provided that the above copyright notice appear in all copies and that
 *   both that copyright notice and this permission notice appear in 
 *   supporting documentation, and that the names of Digital or MIT not be
 *   used in advertising or publicity pertaining to distribution of the
 *   software without specific, written prior permission.  
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 */
/*
** File:
**
**	xvhw_Dummy.h: Hardware layer instance control block for XV video 
**                extension support of Dummy board.
**
** Author:
**
**   Andy Goodrich (Parallax)
**
** Revisions:
**
**   12 Jan 95 Goodrich
**     - Initial coding.
*/
#ifndef xvhw_Dummy_INCLUDED
#define xvhw_Dummy_INCLUDED 

#include "xvhw.h"			/* Standard interface to Pip object. */

#define DUMMY_FB_WIDTH  1280		/* Width of video frame buffer. */
#define DUMMY_FB_HEIGHT 1024		/* Height of video frame buffer. */

/* =============================================================================
 * ||                                                                         ||
 * || X Video Extension Object For Communicating With Video Hardware Support. ||
 * ||                                                                         ||
 * =============================================================================
 */
typedef struct _HwDummy {
	XvhwRec   	  	 public;		   /* Public fields: THIS MUST BE FIRST! */
	Xvhw_Drw_Area 	 drawable_area;    /* Current drawable area */
    int        	  	 fb_height;    	   /* # of lines in host fb. */
	int			  	 fb_pitch;		   /* # of pixels per host fb line. */
	Xvhw_Levels	  	 levels;		   /* Brightness contrast hue & saturation*/
	int			  	 screen;		   /* X11 screen xv is for. */
	Xvhw_Signal	  	 signal;		   /* Signal specification. */
	Xvhw_Sig_Area 	 signal_area;	   /* Current pip source (signal) area. */
	int			  	 video_frozen;     /* = 1 if pip explicitly stopped. */
	int			  	 video_off_semaphore; /* Resume / suspend semaphore. */
	int			  	 wid;		   	   /* Window id for this object. */
} HwDummy;

#endif /* xvhw_Dummy_INCLUDED */
